#include <windows.h>				// 
#include <winbase.h>				// 
#include <stdlib.h>	
#include "resource.h"
#include "Set1D_def.h"
#include "OBRREQ.h"
#include <commctrl.h>
#include <prsht.h>                   // vpeB V[g̃CN[h

#define MAX_LOADSTRING 100

// Global Variables:


HICON hIcon = 0;



extern HINSTANCE			hInst;			// The current instance
extern HWND				hwndCB;			// The command bar handle

// Code Setting
int	gnowCode=SYM_CODE39;
int	gnowCodeCheckDigit ;
int	gnowCodeOutFormat ;
int	gnowCodeReadMode ; 
int	gnowCodeBuzzer ;
int	gnowCodeLed ;
int	gnowCodeOutBuff ;
int	gnowCodeEndCode ;
int	gnowCodeReadActMode ;
int	gnowFilterMode ;							// 02.12.20 ADD


struct CODEPARAM	cparam[NUM_SYMBOLOGIES];	// Code Parameter
struct CODEONOFF	codeonoff[NUM_SYMBOLOGIES];	// Code Enable/Disble

// Code Range / min digit / max digit
const int iMin[NUM_SYMBOLOGIES]={ 2, 2,10, 8, 9,7, 2, 4, 3, 2, 1, 1};
const int iMax[NUM_SYMBOLOGIES]={38,38,18,13,12,7,40,40,40,64,40,40};

const int iMinOnOff[NUM_SYMBOLOGIES]={1,1,0,0,0,0,1,1,1,1,1,1};
const int iMaxOnOff[NUM_SYMBOLOGIES]={1,1,0,0,0,0,1,1,1,1,1,1};
const int iOutFormatOnOff[NUM_SYMBOLOGIES]={1,1,0,0,0,0,0,0,0,1,0,0};
const int iCheckDigitOnOff[NUM_SYMBOLOGIES]={1,0,1,1,1,1,1,1,1,1,1,1};
const int iCheckCharOnOff[NUM_SYMBOLOGIES]={1,0,0,0,1,1,1,1,0,0,1,0};



// R[h̎
const TCHAR CodeList[NUM_SYMBOLOGIES][32] =
	{	TEXT("Code39"),				TEXT("NW-7"),					TEXT("WPC Addon"),//2
		TEXT("WPC"),				TEXT("UPC-E Addon"),			TEXT("UPC-E"),
		TEXT("Industrial2of5(IDF)"),TEXT("Interleaved2of5(ITF)"),	TEXT("Code93"),
		TEXT("Code128"),			TEXT("MSI"),					TEXT("IATA")
	};


// Combobox Order
int CmbOrder[NUM_SYMBOLOGIES]={
	SYM_CODE39, SYM_NW7, SYM_WPCA, SYM_WPC, SYM_UPCA, SYM_UPC, SYM_IDF25, SYM_ITF25,
	SYM_CODE93, SYM_CODE128, SYM_MSI, SYM_IATA25
	};

int Order1D[14]={
	SYM_CODE39, SYM_NW7, SYM_WPCA, SYM_WPC, SYM_UPCA, SYM_UPC, SYM_IDF25, SYM_ITF25,
	SYM_CODE93, SYM_CODE128, SYM_MSI, SYM_IATA25
	};


//// Combobox Order
//int CmbOrder[NUM_SYMBOLOGIES]={
//	SYM_CODE39, SYM_NW7, SYM_WPCA, SYM_WPC, SYM_UPCA, SYM_UPC, SYM_IDF25, SYM_ITF25,
//	SYM_CODE93, SYM_CODE128, SYM_MSI, SYM_IATA25
//	};

const int iOutFormatSize[NUM_SYMBOLOGIES]={4,2,0,0,0,0,0,0,0,5,0,0};
// OUTFORMAT CODE39̎
const TCHAR OutFomatCd39List[NUM_SYMBOLOGIES][32] =
	{	TEXT("Start/StopޗL"), TEXT("Start/Stopޖ"), TEXT("FullASCII,Start/StopޗL"),//2
		TEXT("FullASCII,Start/Stopޖ")
	};


// Combobox Order
int OutFomatCd39Order[NUM_SYMBOLOGIES]={
	SYM_CODE39SON, SYM_CODE39SOFF, SYM_CODE39ASON, CODE39ASOFF
	};

// OUTFORMAT NW7̎
const TCHAR OutFomatNw7List[NUM_SYMBOLOGIES][32] =
	{	TEXT("Start/StopޗL"),	TEXT("Start/Stopޖ")
	};


// Combobox Order
int OutFomatNw7Order[NUM_SYMBOLOGIES]={
	SYM_NW7SON, SYM_NW7SOFF
	};

// OUTFORMAT CODE128̎
const TCHAR OutFomatCd128List[NUM_SYMBOLOGIES][32] =
	{	TEXT("ASCIIϊްo"), TEXT("ASCIIϊOްo"), 
		TEXT("EAN128o͗L"),//2
		TEXT("EAN128 IDo͗L"),	TEXT("EAN128 GSo͗L")
	};


// Combobox Order
int OutFomatCd128Order[NUM_SYMBOLOGIES]={
	SYM_CODE128AON, SYM_CODE128AOFF, SYM_CODE128EAN,SYM_CODE128AIM, SYM_CODE128FNC
	};


const int iCheckDigitSize[NUM_SYMBOLOGIES]={2,2,2,2,2,2,2,2,2,2,4,4};
// Check Digit MSI̎
const TCHAR CheckDigitMsiList[NUM_SYMBOLOGIES][32] =
	{	TEXT("޼ޯĖ"), TEXT("޼ޯėL1(mod10)"), TEXT("޼ޯėL2(mod11 mod10)"),//2
		TEXT("޼ޯėL2(mod10 mod10)")
	};


// Combobox Order
int CheckDigitMsiOrder[NUM_SYMBOLOGIES]={
	SYM_CHKDOFF, SYM_CHKDON, SYM_CMDSEV,SYM_CMDSTN
	};

// Check Digit IATA̎
const TCHAR CheckDigitIataList[NUM_SYMBOLOGIES][32] =
	{	TEXT("޼ޯĖ"), TEXT("޼ޯėL(ŏIވȊOΏ)"), TEXT("޼ޯėL(/l)"),//2
		TEXT("޼ޯėL(l)")
	};


// Combobox Order
int CheckDigitIataOrder[NUM_SYMBOLOGIES]={
	SYM_CHKDOFF, SYM_CHKDON, SYM_CMDSEV,SYM_CMDSTN
	};

// Check Digit ̑̎
const TCHAR CheckDigitAnyList[NUM_SYMBOLOGIES][32] =
	{	TEXT("޼ޯĖ"),	TEXT("޼ޯėL")
	};


// Combobox Order
int CheckDigitAnyOrder[NUM_SYMBOLOGIES]={
	SYM_CHKDOFF, SYM_CHKDON
	};


// ǂݎ胂[h ̎
const TCHAR ReadModeList[NUM_SYMBOL_RDMODE][32] =
	{	TEXT("Pǂ"),	TEXT("Aǂ")
	};


// Combobox Order
int ReadModeOrder[NUM_SYMBOL_RDMODE]={
	SYM_TYPE0, SYM_TYPE1
	};

// uU[ ̎
const TCHAR BuzzerList[NUM_SYMBOLOGIES][32] =
	{	TEXT("޻ް"),	TEXT("޻ްL")
	};


// Combobox Order
int BuzzerOrder[NUM_SYMBOLOGIES]={
	SYM_BUZOFF, SYM_BUZON
	};

// kdc ̎
const TCHAR LedList[NUM_SYMBOLOGIES][32] =
	{	TEXT("LED"),	TEXT("LEDL"),	TEXT("LEDL(G[)")
	};


// Combobox Order
int LedOrder[NUM_SYMBOLOGIES]={
	SYM_LEDOFF, SYM_LEDON, SYM_LEDEROF
	};

// o̓obt@ ̎
const TCHAR OutBuffList[NUM_SYMBOLOGIES][32] =
	{	TEXT("OBRޯ̧o"),	TEXT("үޏo(w賨޳)"),
		TEXT("үޏo(è޳޳)")
	};

// Combobox Order
int OutBuffOrder[NUM_SYMBOLOGIES]={
	SYM_BUFOBR, SYM_STOF, SYM_ASTOF
	};

// ǂݎ蓮샂[h ̎
const TCHAR ReadActModeList[NUM_SYMBOLOGIES][32] =
	{	TEXT("ʏǂ"),	TEXT("iǂ")
	};

// Combobox Order
int ReadActModeOrder[NUM_SYMBOLOGIES]={
	SYM_NORM, SYM_DANN
	};

// IR[h ̎
const TCHAR EndCodeList[NUM_SYMBOLOGIES][32] =
	{	TEXT("I CR"),	TEXT("I LF"),	TEXT("I CR+LF")
	};

// Combobox Order
int EndCodeOrder[NUM_SYMBOLOGIES]={
	SYM_ENDCR, SYM_ENDLF, SYM_ENDCL
	};

int giInidefFlag = 0 ;						// ini File ݒ FLAG OFF

	
int	giCodeTbl[NUM_SYMBOLOGIES] ={
	OBR_CD39, OBR_NW_7, OBR_WPCA, OBR_WPC, OBR_UPCA, OBR_UPC,
	OBR_IDF, OBR_ITF, OBR_CD93, OBR_CD128, OBR_MSI, OBR_IATA
	};


// tB^[h ̎ 02.12.20 ADD
DWORD	gdwFilterTbl[10] ;
const TCHAR FilterModeList[NUM_SYMBOLOGIES][32] =
	{	TEXT("̨"),TEXT("̨L"),TEXT("ʰ̨L"),
		TEXT("/ʰ̨L")
	};
DWORD	gdwFilterTbl2[10] ;
int FilterModeOrder[NUM_SYMBOLOGIES]={
	SYM_NOFILTER, SYM_SOFTFILTER,SYM_HARDFILTER,SYM_SOFTHARDFILTER
	};
DWORD	gdwFilterTbl3[10] ;



const	struct	m_tbl	ObrModeTblDef	 = {		/* 샂[h e[u			*/
			OBR_ALL,
			OBR_RESV, OBR_CD39MIN,  OBR_CD39MAX,  OBR_39SON,  OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_NW_7MIN,  OBR_NW_7MAX,  OBR_NWSON,  OBR_CHKDOFF, OBR_CHKKOFF,
			OBR_RESV, OBR_WPCAMIN,  OBR_WPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_WPC_MIN,  OBR_WPC_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPCAMIN,  OBR_UPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPC_MIN,  OBR_UPC_MAX,  OBR_UPAOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IDF_MIN,  OBR_IDF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_ITF_MIN,  OBR_ITF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_CD93DEF,  OBR_CD93MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_C128DEF,  OBR_C128MAX,  OBR_128AON, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_MSI_MIN,  OBR_MSI_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IATA_MIN0,OBR_IATA_MAX, OBR_OUTOFF, OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_TYPE1, OBR_GAINL, OBR_BUZON, OBR_LEDEROF, OBR_BUFOBR,
			OBR_ENDCR, OBR_NORM,OBR_NULLDATA,
			OBR_CHKCNT,OBR_READCNT,
			OBR_TOTALTIMER,OBR_NOFILTER,OBR_NULLDATA,OBR_NULLDATA
	};



struct	m_tbl	ObrModeTbl	 = {		/* 샂[h e[u			*/
			OBR_ALL,
			OBR_RESV, OBR_CD39MIN,  OBR_CD39MAX,  OBR_39SON,  OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_NW_7MIN,  OBR_NW_7MAX,  OBR_NWSON,  OBR_CHKDOFF, OBR_CHKKOFF,
			OBR_RESV, OBR_WPCAMIN,  OBR_WPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_WPC_MIN,  OBR_WPC_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPCAMIN,  OBR_UPCAMAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_UPC_MIN,  OBR_UPC_MAX,  OBR_UPAOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IDF_MIN,  OBR_IDF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_ITF_MIN,  OBR_ITF_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_CD93DEF,  OBR_CD93MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_C128DEF,  OBR_C128MAX,  OBR_128AON, OBR_CHKDON,  OBR_CHKKOFF,
			OBR_RESV, OBR_MSI_MIN,  OBR_MSI_MAX,  OBR_OUTOFF, OBR_CHKDON,  OBR_CHKKON,
			OBR_RESV, OBR_IATA_MIN0,OBR_IATA_MAX, OBR_OUTOFF, OBR_CHKDOFF, OBR_CHKKON,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_RESV, OBR_DNOT, OBR_DNOT, OBR_DNOT,   OBR_DNOT,    OBR_DNOT,
			OBR_TYPE1, OBR_GAINL, OBR_BUZON, OBR_LEDEROF, OBR_BUFOBR,
			OBR_ENDCR, OBR_NORM,OBR_NULLDATA,
			OBR_CHKCNT,OBR_READCNT,
			OBR_TOTALTIMER,OBR_NOFILTER,OBR_NULLDATA,OBR_NULLDATA
	};

TCHAR	szEndsts[200] ;
TCHAR	ucLength[40] ;


extern	void ModeSetIniDsp(HWND) ;				// Mode Settings \
extern int ini_FileWrite_Proc(void) ;			//
extern void ModeSetGetData(HWND) ;				// Mode Settings GET
extern void ModeData_Set(HWND) ;
extern void	TST_GetCodests(void);				// CODEL/ݒ 02.11.28 ADD
extern void	TST_GetCodeOption(void) ;			// CODEIvVL/ݒ擾 02.11.28 ADD


extern int	radix ;

BOOL CALLBACK ModeDrvModeSetProc (HWND, UINT, WPARAM,LPARAM) ;
int	 Cmd_Proc2 (HWND, UINT, WPARAM, LPARAM) ;
int	TST_SetInix(HWND hWnd) ;

//======================================================================
// BtnDlgProc - mButtonsny[W̃_CAO vV[W
//
BOOL CALLBACK ModeDrvModeSetProc (HWND hWnd, UINT wMsg, WPARAM wParam,
                          LPARAM lParam) {
    HWND hwndMain;
    INT endinf;
	int		Num1D,iRet;
	NMHDR	*nmhdr;

	Num1D=12;
	

    switch (wMsg) {

        case WM_INITDIALOG:

			giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
			ModeSetIniDsp(hWnd) ;		// MODE Settings \


            return TRUE;
        //
        // WM_COMMANDbZ[W̓eC EBhEɓ]
        //
        case WM_COMMAND:
            // ŏ̃`FbN {bNX͎`FbN {bNXł͂Ȃ̂ŁA
            // 蓮ŏԂ`FbN }[N̕\̍XVs

			endinf = Cmd_Proc2(hWnd,wMsg,wParam,lParam ) ;		// R}h
			
			return TRUE;

        //
        // WM_NOTIFYbZ[W̓eC EBhEɓ]
        //
        case WM_NOTIFY:
            // EBhE\̂烁C EBhẼnh擾
            hwndMain = (HWND)GetWindowLong (hWnd, DWL_USER);
			nmhdr = (NMHDR*)lParam;
			switch(nmhdr->code){
				case PSN_SETACTIVE:
					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
					ModeData_Set(hWnd) ;
	
					break;
				
				case PSN_KILLACTIVE:
					giInidefFlag = 0 ;						// ini File ݒ FLAG OFF
					ModeSetGetData(hWnd) ;			// Mode Settings GET
					return TRUE;

				case PSN_APPLY:
					if (giInidefFlag == 1)
					{
						return FALSE;
					}
					ModeSetGetData(hWnd) ;			// Mode Settings GET
					iRet = ini_FileWrite_Proc() ;	// ini File ݏ
					break;
				case PSN_QUERYCANCEL:
					break;
				default:
					return FALSE;
			}

            return FALSE;  // WIȏs킹邽߂FALSEԂ

        case WM_DRAWITEM:
            return TRUE;
    }
    return FALSE;
}

//======================================================================
// Cmd_Proc2 - mLCU_TESTnkbthCoݒvV[W
//
int	 Cmd_Proc2 (HWND hWnd, UINT wMsg, WPARAM wParam,
                          LPARAM lParam) {
	int	iRet;

	iRet = TRUE ;

	return (iRet);
}




//===========================================================================
//	TST_SetIni	-	샂[hݒ vV[W
//
int	TST_SetInix(HWND hWnd) 
{


	
	ObrModeTbl = ObrModeTblDef ;	// ̫Ēl


	return (0) ;

}
