//**************************************************************************//
//																			//
// PROGRAM			: OBR hCoinit@C[h					//
// SYSTEM			: PX-771												//
// FILE				: OBRFILEREAD.C											//
// VERSION			: 0.10													//
// AUTHOR			: CASIO													//
// DATE OF GET		: 02/08/19	0.10										//
// DATE OF UPDATE	: 02/08/19	0.10										//
// FUNCTION			: 														//
// HISTORY			: 														//
// 					: 														//
//					: 														//
//					: 														//
//																			//
//**************************************************************************//


#include <windows.h>				// 
#include <types.h>
#include <stdlib.h>	
#include <winbase.h>				// 

#include	"OBRREQ.h"
#include "Set1D_def.h"


TCHAR	tszIniFileName[] = L"\\Windows\\OBRDRV.INI" ;			// init@C̃t@C

extern const	struct	m_tbl	ObrModeTblDef ;
extern struct	m_tbl	ObrModeTbl ;


//-- 02.11.15 ADD START -----------------------------------------------
#define	base_HEX_char	16			// toϊ̊HEXi16j
#define	base_DEC_char	10			// toϊ̊DECi10j

#define	READCODE_SECTION			0
#define	READCODE_SECTION_LNG		20
#define	CODE39_SECTION				1
#define	CODE39_SECTION_LNG			17
#define	NW7_SECTION					6
#define	NW7_SECTION_LNG				14
#define	WPCA_SECTION				11
#define	WPCA_SECTION_LNG			14
#define	WPC_SECTION					16
#define	WPC_SECTION_LNG				13
#define	UPCA_SECTION				21
#define	UPCA_SECTION_LNG			14
#define	UPC_SECTION					26
#define	UPC_SECTION_LNG				13
#define	IDF_SECTION					31
#define	IDF_SECTION_LNG				18
#define	ITF_SECTION					36
#define	ITF_SECTION_LNG				18
#define	CODE93_SECTION				41
#define	CODE93_SECTION_LNG			17
#define	CODE128_SECTION				46
#define	CODE128_SECTION_LNG			18
#define	MSI_SECTION					51
#define	MSI_SECTION_LNG				13
#define	IATA_SECTION				56
#define	IATA_SECTION_LNG			14
#define	READMODE_SECTION			61
#define	READMODE_SECTION_LNG		19
#define	BUZZER_SECTION				62
#define	BUZZER_SECTION_LNG			24
#define	LED_SECTION					63
#define	LED_SECTION_LNG				21
#define	OUTBUFF_SECTION				64
#define	OUTBUFF_SECTION_LNG			25
#define	ENDCODE_SECTION				65
#define	ENDCODE_SECTION_LNG			19
#define	READCTRLMODE_SECTION		66
#define	READCTRLMODE_SECTION_LNG	28
#define	READCNT_SECTION				67
#define	READCNT_SECTION_LNG			23
#define	CMPCNT_SECTION				68
#define	CMPCNT_SECTION_LNG			23
#define	SCANTIME_SECTION			69
#define	SCANTIME_SECTION_LNG		19

int	radix ;
DWORD	dwBytesWrite2 ;
BYTE	szCrChar[10] = {0x0d,0x0a,0x00} ;


BYTE szReadCodeSection[]    = {"[SCAN Support CODE]"};
BYTE szCode39Section[]      = {"[CODE 39 Option]"};
BYTE szNw7Section[]         = {"[NW 7 Option]"};
BYTE szWpcaSection[]        = {"[WPCA Option]"};
BYTE szWpcSection[]         = {"[WPC Option]"};
BYTE szUpcaSection[]        = {"[UPCA Option]"};
BYTE szUpcSection[]         = {"[UPC Option]"};
BYTE szIdfSection[]         = {"[IDF 2of5 Option]"};
BYTE szItfSection[]         = {"[ITF 2of5 Option]"};
BYTE szCode93Section[]      = {"[CODE 93 Option]"};
BYTE szCode128Section[]     = {"[CODE 128 Option]"};
BYTE szMsiSection[]         = {"[MSI Option]"};
BYTE szIataSection[]        = {"[IATA Option]"};
BYTE szReadModeSection[]    = {"[Read Mode Option]"};
BYTE szBuzzSection[]        = {"[Buzzer Control Option]"};
BYTE szLedSection[]         = {"[Led Control Option]"};
BYTE szOutBuffSection[]     = {"[OutBuff Control Option]"};
BYTE szEndModeCtrlSection[] = {"[Suff Char Option]"};
BYTE szReadCtrlSection[]    = {"[Read Mode Control Option]"};
BYTE szReadCntSection[]     = {"[Read Counnter Option]"};
BYTE szCmpCntSection[]      = {"[Comp Counnter Option]"};
BYTE szScanTimeSection[]    = {"[Scan Time Option]"};


#define	READCODE_HEADLNG			9
#define	CODE39_MIN_HEADLNG			11
#define	CODE39_MAX_HEADLNG			11
#define	CODE39_OUTFORMAT_HEADLNG	17
#define	CODE39_CHKD_HEADLNG			12
#define	CODE39_CHKCH_HEADLNG		13

#define	NW7_MIN_HEADLNG				8
#define	NW7_MAX_HEADLNG				8
#define	NW7_OUTFORMAT_HEADLNG		14
#define	NW7_CHKD_HEADLNG			9
#define	NW7_CHKCH_HEADLNG			10

#define	WPCUNA_MIN_HEADLNG			9				// 02.11.18 CHG
#define	WPCUNA_MAX_HEADLNG			9				// 02.11.18 CHG
#define	WPCUNA_OUTFORMAT_HEADLNG	15				// 02.11.18 CHG
#define	WPCUNA_CHKD_HEADLNG			10				// 02.11.18 CHG
#define	WPCUNA_CHKCH_HEADLNG		11				// 02.11.18 CHG

#define	WPCUNN_MIN_HEADLNG			8				// 02.11.18 CHG
#define	WPCUNN_MAX_HEADLNG			8				// 02.11.18 CHG
#define	WPCUNN_OUTFORMAT_HEADLNG	14				// 02.11.18 CHG
#define	WPCUNN_CHKD_HEADLNG			9				// 02.11.18 CHG
#define	WPCUNN_CHKCH_HEADLNG		10				// 02.11.18 CHG

#define	WPCEA_MIN_HEADLNG			9				// 02.11.18 CHG
#define	WPCEA_MAX_HEADLNG			9				// 02.11.18 CHG
#define	WPCEA_OUTFORMAT_HEADLNG		15				// 02.11.18 CHG
#define	WPCEA_CHKD_HEADLNG			10				// 02.11.18 CHG
#define	WPCEA_CHKCH_HEADLNG			11				// 02.11.18 CHG

#define	WPCEN_MIN_HEADLNG			8				// 02.11.18 CHG
#define	WPCEN_MAX_HEADLNG			8				// 02.11.18 CHG
#define	WPCEN_OUTFORMAT_HEADLNG		14				// 02.11.18 CHG
#define	WPCEN_CHKD_HEADLNG			9				// 02.11.18 CHG
#define	WPCEN_CHKCH_HEADLNG			10				// 02.11.18 CHG


#define	INDSTR2_5_MIN_HEADLNG		14
#define	INDSTR2_5_MAX_HEADLNG		14
#define	INDSTR2_5_OUTFORMAT_HEADLNG	20
#define	INDSTR2_5_CHKD_HEADLNG		15
#define	INDSTR2_5_CHKCH_HEADLNG		16

#define	INTLEV2_5_MIN_HEADLNG		14
#define	INTLEV2_5_MAX_HEADLNG		14
#define	INTLEV2_5_OUTFORMAT_HEADLNG	20
#define	INTLEV2_5_CHKD_HEADLNG		15
#define	INTLEV2_5_CHKCH_HEADLNG		16

#define	CODE93_MIN_HEADLNG			11
#define	CODE93_MAX_HEADLNG			11
#define	CODE93_OUTFORMAT_HEADLNG	17
#define	CODE93_CHKD_HEADLNG			12
#define	CODE93_CHKCH_HEADLNG		13

#define	CODE128_MIN_HEADLNG			12
#define	CODE128_MAX_HEADLNG			12
#define	CODE128_OUTFORMAT_HEADLNG	18
#define	CODE128_CHKD_HEADLNG		13
#define	CODE128_CHKCH_HEADLNG		14

#define	MSI_MIN_HEADLNG				8
#define	MSI_MAX_HEADLNG				8
#define	MSI_OUTFORMAT_HEADLNG		14
#define	MSI_CHKD_HEADLNG			9
#define	MSI_CHKCH_HEADLNG			10

#define	IAIA_MIN_HEADLNG			9
#define	IAIA_MAX_HEADLNG			9
#define	IAIA_OUTFORMAT_HEADLNG		15
#define	IAIA_CHKD_HEADLNG			10
#define	IAIA_CHKCH_HEADLNG			11

#define	READMODE_HEADLNG			9
#define	BUZZER_HEADLNG				7
#define	LEDCTRL_HEADLNG				8
#define	OUTBUFF_HEADLNG				8
#define	ENDCODE_HEADLNG				8
#define	READCTRLMODE_HEADLNG		13
#define	READNORMALCLK_HEADLNG		14
#define	READNORMALLNG_HEADLNG		14
#define	READABNORMALCLK_HEADLNG		16
#define	READABNORMALLNG_HEADLNG		16
#define	READCNT_HEADLNG				8
#define	CMPCNT_HEADLNG				7
#define	SCANTIME_HEADLNG			9
#define	OFFWAITTIME_HEADLNG			12
#define	MIRRORTIME_HEADLNG			11
#define	FILTERMODE_HEADLNG			11					// 02.12.20 ADD
#define	FILTERCNT_HEADLNG			10					// 03.01.16 ADD

#define	INIFILE_NO			72				// 03.01.16 CHG



#define	INIFILEPATH_NO		25
#define	MAX_PATHNAMESIZE 256				// 02.12.03 ADD

int	ini_FileRead_Proc(void) ;
int	Ini_Data_Read(int ) ;
int	Ini_Data_Read2(int ) ;
int IniFilePathGet(void) ;
int ini_FileWrite_Proc(void) ;				// 02.11.18 ADD
int	ini_FileWrite_Section(int) ;			// 02.11.18 ADD

int WD_strncmp(char *,char *,int ) ;
VOID WT_byteMemcopy(LPSTR , LPSTR , DWORD ) ;
VOID WT_GlobalMemSet(LPSTR , CHAR , DWORD ) ;

int oemCreateDirectory(TCHAR *) ;			// ިڸ؍쐬 02.12.03 ADD


struct	Ini_Head_inf_blk {
	int		iHead_lng ;									// ͯްݸ޽
	char	*lpIniHead ;								// ͯް߲
	int		iMaxDataLng ;								// ްMAXݸ޽
} ;
struct	Ini_defult_inf_blk {
	int		iData_lng ;									// ͯްݸ޽
	char	szIniData[80] ;								// ͯް߲
} ;
struct	Ini_Data_blk {
	int		iResouce_Id ;								// ؿID
	int		iMaxDataLng ;								// ްMAXݸ޽
} ;

HANDLE	hIniFile ;										// init@C t@C̃nh

char	szIniFilePath[] = "\\" ;


char	cIniFileName[] = "OBRDRV.INI" ;

TCHAR	tszProcFileName[] = L"OBRDRV.dll" ;				// EXEt@C̃t@C
char	szProcFileName[] = {"OBRDRV.ini"} ;				// EXEt@C
char	szIniFileName[] = {"OBRDRV.INI"} ;				// init@C

// ǂݎR[h
char	szReadCode[] = {"READCODE="} ;					// ǂݎR[hwb_[

// ǂݎ茅ݒ
char	szCode39_Min[] = {"CODE39_MIN="} ;				// CODE-39 MINǂݎ茅wb_[
char	szCode39_Max[] = {"CODE39_MAX="} ;				// CODE-39 MAXǂݎ茅wb_[
char	szCode39_OutFormat[] = {"CODE39_OUTFORMAT="} ;	// CODE-39 o̓tH[}bgwb_[
char	szCode39_Chkd[] = {"CODE39_CHKD="} ;			// CODE-39 `FbNfWbgwb_[
char	szCode39_Chkch[] = {"CODE39_CHKCH="} ;			// CODE-39 `FbNLN^wb_[

char	szNw7_Min[] = {"NW7_MIN="} ;					// NW7 MINǂݎ茅wb_[
char	szNw7_Max[] = {"NW7_MAX="} ;					// NW7 MAXǂݎ茅wb_[
char	szNw7_OutFormat[] = {"NW7_OUTFORMAT="} ;		// NW7 o̓tH[}bgwb_[
char	szNw7_Chkd[] = {"NW7_CHKD="} ;					// NW7 `FbNfWbgwb_[
char	szNw7_Chkch[] = {"NW7_CHKCH="} ;				// NW7 `FbNLN^wb_[

char	szWpcuna_Min[] = {"WPCA_MIN="} ;				// WPCUNA MINǂݎ茅wb_[ 02.11.15 CHG
char	szWpcuna_Max[] = {"WPCA_MAX="} ;				// WPCUNA MAXǂݎ茅wb_[ 02.11.15 CHG
char	szWpcuna_OutFormat[] = {"WPCA_OUTFORMAT="} ;	// WPCUNA o̓tH[}bgwb_[ 02.11.15 CHG
char	szWpcuna_Chkd[] = {"WPCA_CHKD="} ;			// WPCUNA `FbNfWbgwb_[ 02.11.15 CHG
char	szWpcuna_Chkch[] = {"WPCA_CHKCH="} ;			// WPCUNA `FbNLN^wb_[ 02.11.15 CHG

char	szWpcunn_Min[] = {"WPC_MIN="} ;				// WPCUNN MINǂݎ茅wb_[ 02.11.15 CHG
char	szWpcunn_Max[] = {"WPC_MAX="} ;				// WPCUNN MAXǂݎ茅wb_[ 02.11.15 CHG
char	szWpcunn_OutFormat[] = {"WPC_OUTFORMAT="} ;	// WPCUNN o̓tH[}bgwb_[ 02.11.15 CHG
char	szWpcunn_Chkd[] = {"WPC_CHKD="} ;			// WPCUNN `FbNfWbgwb_[ 02.11.15 CHG
char	szWpcunn_Chkch[] = {"WPC_CHKCH="} ;			// WPCUNN `FbNLN^wb_[ 02.11.15 CHG

char	szWpcea_Min[] = {"UPCA_MIN="} ;				// WPCEA MINǂݎ茅wb_[ 02.11.15 CHG
char	szWpcea_Max[] = {"UPCA_MAX="} ;				// WPCEA MAXǂݎ茅wb_[ 02.11.15 CHG
char	szWpcea_OutFormat[] = {"UPCA_OUTFORMAT="} ;	// WPCEA o̓tH[}bgwb_[ 02.11.15 CHG
char	szWpcea_Chkd[] = {"UPCA_CHKD="} ;				// WPCEA `FbNfWbgwb_[ 02.11.15 CHG
char	szWpcea_Chkch[] = {"UPCA_CHKCH="} ;			// WPCEA `FbNLN^wb_[ 02.11.15 CHG

char	szWpcen_Min[] = {"UPC_MIN="} ;				// WPCEN MINǂݎ茅wb_[ 02.11.15 CHG
char	szWpcen_Max[] = {"UPC_MAX="} ;				// WPCEN MAXǂݎ茅wb_[ 02.11.15 CHG
char	szWpcen_OutFormat[] = {"UPC_OUTFORMAT="} ;	// WPCEN o̓tH[}bgwb_[ 02.11.15 CHG
char	szWpcen_Chkd[] = {"UPC_CHKD="} ;				// WPCEN `FbNfWbgwb_[ 02.11.15 CHG
char	szWpcen_Chkch[] = {"UPC_CHKCH="} ;			// WPCEN `FbNLN^wb_[ 02.11.15 CHG

char	szINDSTR2_5_Min[] = {"INDSTR2_5_MIN="} ;		// IUNDUSTRIAL 2_5 MINǂݎ茅wb_[
char	szINDSTR2_5_Max[] = {"INDSTR2_5_MAX="} ;		// IUNDUSTRIAL 2_5 MAXǂݎ茅wb_[
char	szINDSTR2_5_OutFormat[] = {"INDSTR2_5_OUTFORMAT="} ; // IUNDUSTRIAL 2_5 o̓tH[}bgwb_[
char	szINDSTR2_5_Chkd[] = {"INDSTR2_5_CHKD="} ;		// IUNDUSTRIAL 2_5 `FbNfWbgwb_[
char	szINDSTR2_5_Chkch[] = {"INDSTR2_5_CHKCH="} ;	// IUNDUSTRIAL 2_5 `FbNLN^wb_[

char	szIntLev2_5_Min[] = {"INTLEV2_5_MIN="} ;		// INTERLEAVED 2_5 MINǂݎ茅wb_[
char	szIntLev2_5_Max[] = {"INTLEV2_5_MAX="} ;		// INTERLEAVED 2_5 MAXǂݎ茅wb_[
char	szIntLev2_5_OutFormat[] = {"INTLEV2_5_OUTFORMAT="} ; // INTERLEAVED 2_5 o̓tH[}bgwb_[
char	szIntLev2_5_Chkd[] = {"INTLEV2_5_CHKD="} ;		// INTERLEAVED 2_5 `FbNfWbgwb_[
char	szIntLev2_5_Chkch[] = {"INTLEV2_5_CHKCH="} ;	// INTERLEAVED 2_5 `FbNLN^wb_[

char	szCode93_Min[] = {"CODE93_MIN="} ;				// CODE-93 MINǂݎ茅wb_[
char	szCode93_Max[] = {"CODE93_MAX="} ;				// CODE-93 MAXǂݎ茅wb_[
char	szCode93_OutFormat[] = {"CODE93_OUTFORMAT="} ;	// CODE-93 o̓tH[}bgwb_[
char	szCode93_Chkd[] = {"CODE93_CHKD="} ;			// CODE-93 `FbNfWbgwb_[
char	szCode93_Chkch[] = {"CODE93_CHKCH="} ;			// CODE-93 `FbNLN^wb_[

char	szCode128_Min[] = {"CODE128_MIN="} ;			// CODE-128 MINǂݎ茅wb_[
char	szCode128_Max[] = {"CODE128_MAX="} ;			// CODE-128 MAXǂݎ茅wb_[
char	szCode128_OutFormat[] = {"CODE128_OUTFORMAT="} ; // CODE-128 o̓tH[}bgwb_[
char	szCode128_Chkd[] = {"CODE128_CHKD="} ;			// CODE-128 `FbNfWbgwb_[
char	szCode128_Chkch[] = {"CODE128_CHKCH="} ;		// CODE-128 `FbNLN^wb_[

char	szMsi_Min[] = {"MSI_MIN="} ;					// MSI MINǂݎ茅wb_[
char	szMsi_Max[] = {"MSI_MAX="} ;					// MSI MAXǂݎ茅wb_[
char	szMsi_OutFormat[] = {"MSI_OUTFORMAT="} ;		// MSI o̓tH[}bgwb_[
char	szMsi_Chkd[] = {"MSI_CHKD="} ;					// MSI `FbNfWbgwb_[
char	szMsi_Chkch[] = {"MSI_CHKCH="} ;				// MSI `FbNLN^wb_[

char	szIaia_Min[] = {"IAIA_MIN="} ;					// IAIA MINǂݎ茅wb_[
char	szIaia_Max[] = {"IAIA_MAX="} ;					// IAIA MAXǂݎ茅wb_[
char	szIaia_OutFormat[] = {"IAIA_OUTFORMAT="} ;		// IAIA o̓tH[}bgwb_[
char	szIaia_Chkd[] = {"IAIA_CHKD="} ;				// IAIA `FbNfWbgwb_[
char	szIaia_Chkch[] = {"IAIA_CHKCH="} ;				// IAIA `FbNLN^wb_[

// ǂݎ
char	szReadMode[] = {"READMODE="} ;					// ǂݎ

// uU[
char	szBuzzer[] = {"BUZZER="} ;						// uU[

// kdc
char	szLedctrl[] = {"LEDCTRL="} ;					// kdc

// o̓obt@
char	szOutbuff[] = {"OUTBUFF="} ;					// ǂݎ

// IR[h
char	szEndcode[] = {"ENDCODE="} ;					// ǂݎ

// ǂݎ蓮ݒ
char	szReadCtrlMode[] = {"READCTRLMODE="} ;			// ǂݎ

// ǂݎ萳퉹g
char	szReadNormalClk[] = {"READNORMALCLK="} ;		// ǂݎ萳퉹g

// ǂݎ萳퉹
char	szReadNormalLng[] = {"READNORMALLNG="} ;		// ǂݎ萳퉹

// ǂݎُ퉹g
char	szReadABNormalClk[] = {"READABNORMALCLK="} ;	// ǂݎُ퉹g

// ǂݎُ퉹
char	szReadABNormalLng[] = {"READABNORMALLNG="} ;	// ǂݎُ퉹

// ǂݎ
char	szReadCnt[] = {"READCNT="} ;					// ǂݎ

// ƍ
char	szCmpCnt[] = {"CMPCNT="} ;						// ƍ

// XL
char	szScanTime[] = {"SCANTIME="} ;					// XL

// neev
char	szOffWaitTime[] = {"OFFWAITTIME="} ;					// neev

// FILTER MODE
char	szFilterMode[] = {"FILTERMODE="} ;				// tB^[h 02.12.20 ADD

// FILTER COUNTER
char	szFilterCnt[] = {"FILTERCNT="} ;				// tB^[hJE^ 03.01.16 ADD

// ~[莞
char	szMirrorTime[] = {"MIRRORTIME="} ;				//  ~[莞



char	cFileName[100] ;								// t@C
char	cOldLogName[100] ;								// ݒLOĢٖ
							

DWORD	dwRead_Endlng ;
char	cCurrentPath[400] ;

char	cIniFileData[INIFILE_NO][80] ;					// ini̧ٕҏWޯ̧ð(o͗p)
TCHAR	tcIniFileData[INIFILE_NO][80] ;					// ini̧ٕҏWޯ̧ð(o͗p)

char	cInData_buf[800] ;								// ini̧ٓǂݍޯ̧
char	cInData_buf2[800] ;								// ini̧ٓǂݍޯ̧
//TCHAR	tcInData_buf[800] ;								// ini̧ٓǂݍޯ̧

//TCHAR	tcWorkIniData[800] ;							// _CO\pGA

struct	Ini_Head_inf_blk	Ini_Head_in[INIFILE_NO] =	{
							{(int)READCODE_HEADLNG,szReadCode,10},
							{(int)CODE39_MIN_HEADLNG,szCode39_Min,4},
							{(int)CODE39_MAX_HEADLNG,szCode39_Max,4},
							{(int)CODE39_OUTFORMAT_HEADLNG,szCode39_OutFormat,4},
							{(int)CODE39_CHKD_HEADLNG,szCode39_Chkd,4},
							{(int)CODE39_CHKCH_HEADLNG,szCode39_Chkch,4},
							{(int)NW7_MIN_HEADLNG,szNw7_Min,4},
							{(int)NW7_MAX_HEADLNG,szNw7_Max,4},
							{(int)NW7_OUTFORMAT_HEADLNG,szNw7_OutFormat,4},
							{(int)NW7_CHKD_HEADLNG,szNw7_Chkd,4},
							{(int)NW7_CHKCH_HEADLNG,szNw7_Chkch,4},
							{(int)WPCUNA_MIN_HEADLNG,szWpcuna_Min,4},
							{(int)WPCUNA_MAX_HEADLNG,szWpcuna_Max,4},
							{(int)WPCUNA_OUTFORMAT_HEADLNG,szWpcuna_OutFormat,4},
							{(int)WPCUNA_CHKD_HEADLNG,szWpcuna_Chkd,4},
							{(int)WPCUNA_CHKCH_HEADLNG,szWpcuna_Chkch,4},
							{(int)WPCUNN_MIN_HEADLNG,szWpcunn_Min,4},
							{(int)WPCUNN_MAX_HEADLNG,szWpcunn_Max,4},
							{(int)WPCUNN_OUTFORMAT_HEADLNG,szWpcunn_OutFormat,4},
							{(int)WPCUNN_CHKD_HEADLNG,szWpcunn_Chkd,4},
							{(int)WPCUNN_CHKCH_HEADLNG,szWpcunn_Chkch,4},
							{(int)WPCEA_MIN_HEADLNG,szWpcea_Min,4},
							{(int)WPCEA_MAX_HEADLNG,szWpcea_Max,4},
							{(int)WPCEA_OUTFORMAT_HEADLNG,szWpcea_OutFormat,4},
							{(int)WPCEA_CHKD_HEADLNG,szWpcea_Chkd,4},
							{(int)WPCEA_CHKCH_HEADLNG,szWpcea_Chkch,4},
							{(int)WPCEN_MIN_HEADLNG,szWpcen_Min,4},
							{(int)WPCEN_MAX_HEADLNG,szWpcen_Max,4},
							{(int)WPCEN_OUTFORMAT_HEADLNG,szWpcen_OutFormat,4},
							{(int)WPCEN_CHKD_HEADLNG,szWpcen_Chkd,4},
							{(int)WPCEN_CHKCH_HEADLNG,szWpcen_Chkch,4},
							{(int)INDSTR2_5_MIN_HEADLNG,szINDSTR2_5_Min,4},
							{(int)INDSTR2_5_MAX_HEADLNG,szINDSTR2_5_Max,4},
							{(int)INDSTR2_5_OUTFORMAT_HEADLNG,szINDSTR2_5_OutFormat,4},
							{(int)INDSTR2_5_CHKD_HEADLNG,szINDSTR2_5_Chkd,4},
							{(int)INDSTR2_5_CHKCH_HEADLNG,szINDSTR2_5_Chkch,4},
							{(int)INTLEV2_5_MIN_HEADLNG,szIntLev2_5_Min,4},
							{(int)INTLEV2_5_MAX_HEADLNG,szIntLev2_5_Max,4},
							{(int)INTLEV2_5_OUTFORMAT_HEADLNG,szIntLev2_5_OutFormat,4},
							{(int)INTLEV2_5_CHKD_HEADLNG,szIntLev2_5_Chkd,4},
							{(int)INTLEV2_5_CHKCH_HEADLNG,szIntLev2_5_Chkch,4},
							{(int)CODE93_MIN_HEADLNG,szCode93_Min,4},
							{(int)CODE93_MAX_HEADLNG,szCode93_Max,4},
							{(int)CODE93_OUTFORMAT_HEADLNG,szCode93_OutFormat,4},
							{(int)CODE93_CHKD_HEADLNG,szCode93_Chkd,4},
							{(int)CODE93_CHKCH_HEADLNG,szCode93_Chkch,4},
							{(int)CODE128_MIN_HEADLNG,szCode128_Min,4},
							{(int)CODE128_MAX_HEADLNG,szCode128_Max,4},
							{(int)CODE128_OUTFORMAT_HEADLNG,szCode128_OutFormat,4},
							{(int)CODE128_CHKD_HEADLNG,szCode128_Chkd,4},
							{(int)CODE128_CHKCH_HEADLNG,szCode128_Chkch,4},
							{(int)MSI_MIN_HEADLNG,szMsi_Min,4},
							{(int)MSI_MAX_HEADLNG,szMsi_Max,4},
							{(int)MSI_OUTFORMAT_HEADLNG,szMsi_OutFormat,4},
							{(int)MSI_CHKD_HEADLNG,szMsi_Chkd,4},
							{(int)MSI_CHKCH_HEADLNG,szMsi_Chkch,4},
							{(int)IAIA_MIN_HEADLNG,szIaia_Min,4},
							{(int)IAIA_MAX_HEADLNG,szIaia_Max,4},
							{(int)IAIA_OUTFORMAT_HEADLNG,szIaia_OutFormat,4},
							{(int)IAIA_CHKD_HEADLNG,szIaia_Chkd,4},
							{(int)IAIA_CHKCH_HEADLNG,szIaia_Chkch,4},
							{(int)READMODE_HEADLNG,szReadMode,4},
							{(int)BUZZER_HEADLNG,szBuzzer,4},
							{(int)LEDCTRL_HEADLNG,szLedctrl,4},
							{(int)OUTBUFF_HEADLNG,szOutbuff,4},
							{(int)ENDCODE_HEADLNG,szEndcode,4},
							{(int)READCTRLMODE_HEADLNG,szReadCtrlMode,4},
							{(int)READCNT_HEADLNG,szReadCnt,4},
							{(int)CMPCNT_HEADLNG,szCmpCnt,4},
							{(int)SCANTIME_HEADLNG,szScanTime,10},
							{(int)FILTERMODE_HEADLNG,szFilterMode,10},
							{(int)FILTERCNT_HEADLNG,szFilterCnt,10}
							} ;
											// яTBLCHG 02.10.03 CHG 
char	*lpIniDataTbl[INIFILE_NO] = {
							(char *)&ObrModeTbl.Code,
							(char *)&ObrModeTbl.Cd39[1],
							(char *)&ObrModeTbl.Cd39[2],
							(char *)&ObrModeTbl.Cd39[3],
							(char *)&ObrModeTbl.Cd39[4],
							(char *)&ObrModeTbl.Cd39[5],
							(char *)&ObrModeTbl.Nw7[1],
							(char *)&ObrModeTbl.Nw7[2],
							(char *)&ObrModeTbl.Nw7[3],
							(char *)&ObrModeTbl.Nw7[4],
							(char *)&ObrModeTbl.Nw7[5],
							(char *)&ObrModeTbl.Wpcea[1],
							(char *)&ObrModeTbl.Wpcea[2],
							(char *)&ObrModeTbl.Wpcea[3],
							(char *)&ObrModeTbl.Wpcea[4],
							(char *)&ObrModeTbl.Wpcea[5],
							(char *)&ObrModeTbl.Wpce[1],
							(char *)&ObrModeTbl.Wpce[2],
							(char *)&ObrModeTbl.Wpce[3],
							(char *)&ObrModeTbl.Wpce[4],
							(char *)&ObrModeTbl.Wpce[5],
							(char *)&ObrModeTbl.Upcea[1],
							(char *)&ObrModeTbl.Upcea[2],
							(char *)&ObrModeTbl.Upcea[3],
							(char *)&ObrModeTbl.Upcea[4],
							(char *)&ObrModeTbl.Upcea[5],
							(char *)&ObrModeTbl.Upce[1],
							(char *)&ObrModeTbl.Upce[2],
							(char *)&ObrModeTbl.Upce[3],
							(char *)&ObrModeTbl.Upce[4],
							(char *)&ObrModeTbl.Upce[5],
							(char *)&ObrModeTbl.Idsf[1],
							(char *)&ObrModeTbl.Idsf[2],
							(char *)&ObrModeTbl.Idsf[3],
							(char *)&ObrModeTbl.Idsf[4],
							(char *)&ObrModeTbl.Idsf[5],
							(char *)&ObrModeTbl.Itrf[1],
							(char *)&ObrModeTbl.Itrf[2],
							(char *)&ObrModeTbl.Itrf[3],
							(char *)&ObrModeTbl.Itrf[4],
							(char *)&ObrModeTbl.Itrf[5],
							(char *)&ObrModeTbl.Cd93[1],
							(char *)&ObrModeTbl.Cd93[2],
							(char *)&ObrModeTbl.Cd93[3],
							(char *)&ObrModeTbl.Cd93[4],
							(char *)&ObrModeTbl.Cd93[5],
							(char *)&ObrModeTbl.Cd128[1],
							(char *)&ObrModeTbl.Cd128[2],
							(char *)&ObrModeTbl.Cd128[3],
							(char *)&ObrModeTbl.Cd128[4],
							(char *)&ObrModeTbl.Cd128[5],
							(char *)&ObrModeTbl.Msi[1],
							(char *)&ObrModeTbl.Msi[2],
							(char *)&ObrModeTbl.Msi[3],
							(char *)&ObrModeTbl.Msi[4],
							(char *)&ObrModeTbl.Msi[5],
							(char *)&ObrModeTbl.Iata[1],
							(char *)&ObrModeTbl.Iata[2],
							(char *)&ObrModeTbl.Iata[3],
							(char *)&ObrModeTbl.Iata[4],
							(char *)&ObrModeTbl.Iata[5],
							(char *)&ObrModeTbl.Type,
							(char *)&ObrModeTbl.Buzc,
							(char *)&ObrModeTbl.Ledc,
							(char *)&ObrModeTbl.Bufc,
							(char *)&ObrModeTbl.Endc,
							(char *)&ObrModeTbl.Mode,
							(char *)&ObrModeTbl.rd_ct,
							(char *)&ObrModeTbl.cmp_ct,
							(char *)&ObrModeTbl.scn_tm,
							(char *)&ObrModeTbl.dwFilterMode,
							(char *)&ObrModeTbl.dwFilterCnt
							} ;





											// яTBLCHG 02.11.18 ADD 
char	*lpOutIniDataTbl[INIFILE_NO] = {
							(char *)&ObrModeTbl.Code,
							(char *)&ObrModeTbl.Cd39[1],
							(char *)&ObrModeTbl.Cd39[2],
							(char *)&ObrModeTbl.Cd39[3],
							(char *)&ObrModeTbl.Cd39[4],
							(char *)&ObrModeTbl.Cd39[5],
							(char *)&ObrModeTbl.Nw7[1],
							(char *)&ObrModeTbl.Nw7[2],
							(char *)&ObrModeTbl.Nw7[3],
							(char *)&ObrModeTbl.Nw7[4],
							(char *)&ObrModeTbl.Nw7[5],
							(char *)&ObrModeTbl.Wpcea[1],
							(char *)&ObrModeTbl.Wpcea[2],
							(char *)&ObrModeTbl.Wpcea[3],
							(char *)&ObrModeTbl.Wpcea[4],
							(char *)&ObrModeTbl.Wpcea[5],
							(char *)&ObrModeTbl.Wpce[1],
							(char *)&ObrModeTbl.Wpce[2],
							(char *)&ObrModeTbl.Wpce[3],
							(char *)&ObrModeTbl.Wpce[4],
							(char *)&ObrModeTbl.Wpce[5],
							(char *)&ObrModeTbl.Upcea[1],
							(char *)&ObrModeTbl.Upcea[2],
							(char *)&ObrModeTbl.Upcea[3],
							(char *)&ObrModeTbl.Upcea[4],
							(char *)&ObrModeTbl.Upcea[5],
							(char *)&ObrModeTbl.Upce[1],
							(char *)&ObrModeTbl.Upce[2],
							(char *)&ObrModeTbl.Upce[3],
							(char *)&ObrModeTbl.Upce[4],
							(char *)&ObrModeTbl.Upce[5],
							(char *)&ObrModeTbl.Idsf[1],
							(char *)&ObrModeTbl.Idsf[2],
							(char *)&ObrModeTbl.Idsf[3],
							(char *)&ObrModeTbl.Idsf[4],
							(char *)&ObrModeTbl.Idsf[5],
							(char *)&ObrModeTbl.Itrf[1],
							(char *)&ObrModeTbl.Itrf[2],
							(char *)&ObrModeTbl.Itrf[3],
							(char *)&ObrModeTbl.Itrf[4],
							(char *)&ObrModeTbl.Itrf[5],
							(char *)&ObrModeTbl.Cd93[1],
							(char *)&ObrModeTbl.Cd93[2],
							(char *)&ObrModeTbl.Cd93[3],
							(char *)&ObrModeTbl.Cd93[4],
							(char *)&ObrModeTbl.Cd93[5],
							(char *)&ObrModeTbl.Cd128[1],
							(char *)&ObrModeTbl.Cd128[2],
							(char *)&ObrModeTbl.Cd128[3],
							(char *)&ObrModeTbl.Cd128[4],
							(char *)&ObrModeTbl.Cd128[5],
							(char *)&ObrModeTbl.Msi[1],
							(char *)&ObrModeTbl.Msi[2],
							(char *)&ObrModeTbl.Msi[3],
							(char *)&ObrModeTbl.Msi[4],
							(char *)&ObrModeTbl.Msi[5],
							(char *)&ObrModeTbl.Iata[1],
							(char *)&ObrModeTbl.Iata[2],
							(char *)&ObrModeTbl.Iata[3],
							(char *)&ObrModeTbl.Iata[4],
							(char *)&ObrModeTbl.Iata[5],
							(char *)&ObrModeTbl.Type,
							(char *)&ObrModeTbl.Buzc,
							(char *)&ObrModeTbl.Ledc,
							(char *)&ObrModeTbl.Bufc,
							(char *)&ObrModeTbl.Endc,
							(char *)&ObrModeTbl.Mode,
							(char *)&ObrModeTbl.rd_ct,
							(char *)&ObrModeTbl.cmp_ct,
							(char *)&ObrModeTbl.scn_tm,
							(char *)&ObrModeTbl.dwFilterMode,
							(char *)&ObrModeTbl.dwFilterCnt
							} ;

BYTE	gszDllFileName[256] = {"          "} ;		// 02.09.10 HEN
BYTE	gszIniFileName[256] = {"          "} ;	// 02.09.10 HEN
BYTE	gszChkFileName[256] = {"          "} ;		// 02.09.10 ADD
TCHAR	tszDll_FileName[50] = L"\\DECORDDRV.dll" ;		// ̫RAŞٖ 02.09.10 ADD
TCHAR	tszIni_FileName[50] = L"\\OBRDRV.ini" ;	// ̫ڰ̧ٖ 02.09.10 ADD
TCHAR	tszIni_DefFileName[50] = L"\\FlashDisk\\Casio\\OBRDRV.ini" ;	// ̫ڰ̧ٖ 02.12.19 CHG
TCHAR	tszIni_DefFilePath[50] = L"FlashDisk\\Casio\\" ;	// ̫ڰ̧ٖ 02.12.19 CHG




//**************************************************************************//
//	FUNCTION :	ini_FileRead_Proc  iniFile Ǎݏ						//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	iRaed_cnt1		| int			| I | Read 							//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int	ini_FileRead_Proc() {

	int		iRet,iStop_flg,iRaed_cnt1 ;
	BOOL	bRet ;
	DWORD	dwEcode ;		// 02.12.03 ADD
									
										// ̃t@CI[v 02.10.03 CHG
	hIniFile = CreateFile((LPTSTR)tszIni_DefFileName
						,(GENERIC_READ)
						,FILE_SHARE_READ,NULL,OPEN_EXISTING
						,FILE_ATTRIBUTE_NORMAL, NULL) ;
	if(hIniFile == INVALID_HANDLE_VALUE)
	{
		dwEcode = GetLastError() ;
		if (dwEcode == (DWORD)ERROR_PATH_NOT_FOUND)
		{		// ̧߽װ ?
			oemCreateDirectory(tszIni_DefFilePath);	// CreateDirectory 02.12.03 ADD
			hIniFile = CreateFile((LPTSTR)tszIni_DefFileName
							,(GENERIC_READ)
							,FILE_SHARE_READ,NULL,OPEN_EXISTING
							,FILE_ATTRIBUTE_NORMAL, NULL) ;
		}
		else
		{
			return (0) ;
		}
	}

	iStop_flg = 0 ;							// ~ر
	iRaed_cnt1 = 0 ;
	while (1) {

		 bRet = ReadFile(hIniFile,(LPVOID)&cInData_buf[iRaed_cnt1]
						,(DWORD)1
						,(LPDWORD)&dwRead_Endlng, NULL) ;
		if (bRet == TRUE && dwRead_Endlng == 0) {		// ُ̧I[ ?
			iRet = 0 ;
			break ;
		} else if (bRet == FALSE) {						// ُI ?
			iRet = -1 ;
			break ;
		}
		if (cInData_buf[iRaed_cnt1] == '=') {
			iRet = Ini_Data_Read(iRaed_cnt1) ;			// ini̧قDATAذޏ
			if ((iRet != 0) && (iRet != 2)) {			// t@CEOF܂ُ͈IɂI
				break ;
			}
			iRaed_cnt1 = 0 ;
			continue ;
		} else if ((cInData_buf[iRaed_cnt1] == 0x0d)
					|| (cInData_buf[iRaed_cnt1] == 0x0a)) {		// CR ro LF ?
			iRaed_cnt1 = 0 ;
			continue ;
		}
		iRaed_cnt1 += 1;
	
		if (iStop_flg == 1) break ;
	}


	 bRet = CloseHandle(hIniFile) ;


	return(iRet) ;

}

//**************************************************************************//
//	FUNCTION :	IniFilePathGet  iniFile ̧߽ GET						//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//					| 				| 	| 									//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int IniFilePathGet()
{
	int	iRet ;

	iRet = memcmp(&gszIniFileName[0],&gszChkFileName[0],_FILE_CHK_LNG);
	if (iRet == (int)NULL) {						// ڼ޽؂RAŞٖ`
		memcpy((void *)&gszIniFileName[0],(const void *)&tszIni_FileName[0],_INIDEF_LNG);
		iRet = _INIDEF_LNG ;
	}
	else
	{
		iRet = strlen(&gszIniFileName[0]);
	}


	return(iRet) ;
}

//**************************************************************************//
//	FUNCTION :	Ini_Data_Read  iniFile Ǎݏ(ݒް)				//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	iRaed_cnt1		| int			| I | Read 							//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int	Ini_Data_Read(int iRaed_cnt1) {

	int		iRet,ii ;



	
	for (ii=0;ii<INIFILE_NO;ii++) {
		iRet = WD_strncmp(&cInData_buf[0],Ini_Head_in[ii].lpIniHead
							,(int)Ini_Head_in[ii].iHead_lng) ;
		if (iRet == 0) {				// ꕶ ? 
			iRet = Ini_Data_Read2(ii) ;			// ini̧قDATAذޏ
			return (iRet) ;
		}

	}

	return((int)2) ;

}





//**************************************************************************//
//	FUNCTION :	Ini_Data_Read2  iniFile Ǎݏ(ݒް)				//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	iHead_no		| int			| I | ݒްޔԍ					//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int	Ini_Data_Read2(int iHead_no) {

	int		ii ;
	BOOL	bRet ;
	char	*lpOutBuf ;
	char	*lpOutBuf2 ;
	long	lData ;


	WT_GlobalMemSet(&cInData_buf2[0],0x00,800) ;			// obt@NA
	lpOutBuf = (char *)&cInData_buf2[0] ;
	lpOutBuf2 = (char *)lpIniDataTbl[iHead_no] ;
	for (ii=0;ii<Ini_Head_in[iHead_no].iMaxDataLng;ii++) {
		bRet = ReadFile(hIniFile,(LPVOID)(lpOutBuf+ii)
						,(DWORD)1
						,(LPDWORD)&dwRead_Endlng, NULL) ;
		if (bRet == TRUE && dwRead_Endlng == 0) {		// ُ̧I[ ?
			return((int)1) ;
		} else if (bRet == FALSE) {						// ُI ?
			return((int)-1) ;
		} else if ((*(lpOutBuf+ii)) == 0x0d) {
			*(lpOutBuf+ii) = 0x00 ;					// CR -> NULL
			if (ii == 0)
			{
				return((int)0) ;					// DATAȂ LްǍݏI
			}
			else
			{
				break ;								// LްǍٰߒ~
			}
		}
	
			
	}

	lData = atoi(&cInData_buf2[0]) ;				// ->lϊ

	if (Ini_Head_in[iHead_no].iMaxDataLng == 10)
	{
		memcpy(lpIniDataTbl[iHead_no],&lData,4) ;			// 02.10.03 ADD
	}
	else if (Ini_Head_in[iHead_no].iMaxDataLng == 6)
	{
		memcpy(lpIniDataTbl[iHead_no],&lData,2) ;			// 02.10.03 ADD
	}
	else
	{
		*lpIniDataTbl[iHead_no] = (char)lData ;
	}

	return((int)2) ;

}




//**************************************************************************//
//																			//
//	FUNCTION :	WD_strncmp  ޯ̧r								//
//	str1buff		|char *			| I	| rޯ̧1߲					//
//	str2buf			|char *			| I	| rޯ̧2߲					//
//	srclen			|int			| I	| rݸ޽l						//
//					|int			| O	| ߂l							//
//					|				|	| 0  	:rޯ̧v				//
//					|				|	| NOT 0 :rޯ̧sv			//
//**************************************************************************//
int WD_strncmp(char *str1buff,char *str2buf,int srclen)
{
	int dstlen = 0;
	int wklen = 0;
	int wkslen = 0;
	int nRet = 0;


	nRet = 0 ;
	for(wklen=0; wklen<srclen; wklen++){
		if (str1buff[wklen] != str2buf[wklen]) {				//rsv ?
			nRet = srclen - wklen;
			break;
		}
	}

	return(nRet);

}

//**************************************************************************//
//	MODULE ID:	4-3															//
//	FUNCTION :	WT_byteMemcopy  ؕʏ(BYTE)							//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	INPUT			| LPSTR			| I | ʌڽ						//
//	OUTPUT			| LPSTR			| I | ʐڽ						//
//	Length			| DWORD			| I | ʂݸ޽						//
//**************************************************************************//

VOID WT_byteMemcopy(LPSTR INPUT, LPSTR OUTPUT, DWORD Length)
{

	if (Length < 1)	return ;									// 0ȉ
	for( ; Length ; --Length ) {
		*OUTPUT = *INPUT ;										// ؕ
		++INPUT ;												// NEXT ADDRESS
		++OUTPUT ;
	}

	return ;
}


//**************************************************************************//
//	MODULE ID:	4-2															//
//	FUNCTION :	WT_GlobalMemSet  ؂Ɉ̒lݒ肷					//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	Mem_addr		| LPSTR			| I | ؂̱ڽ						//
//	SetChar			| CHAR			| I | ݒ肷l						//
//	Length			| DWORD			| I | ݒ肷ݸ޽					//
//**************************************************************************//

VOID WT_GlobalMemSet(LPSTR Mem_addr, CHAR SetChar, DWORD Length)
{
	USHORT	i ;

	if (Length < 1)	return ;									// 0ȉ
	for( i=0 ; i<Length ; i++ ) {
		*Mem_addr = SetChar ;
		Mem_addr++ ;
	}

	return ;
}




//**************************************************************************//
//	FUNCTION :	ini_FileWrite_Proc  iniFileݏ						//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//					| 				| - | 									//
//					| 				| - | 									//
//					| 				| - | 									//
//**************************************************************************//
int ini_FileWrite_Proc(void) 
{

	int		ii,iRet,iStop_flg,iRaed_cnt1,iPath_lng ;
	BOOL	bRet ;
	DWORD	dwEcode,dwWork,*lpdwData ;

	iPath_lng = IniFilePathGet() ;
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPCSTR) &szIniFileName[0],
						40, (WCHAR *) &tcIniFileData[0], (iPath_lng+13));

											// VKI[vit@Cݎ0޲Ăɂj
	hIniFile = CreateFile((LPTSTR)tszIni_DefFileName
						,(GENERIC_READ | GENERIC_WRITE)
						,FILE_SHARE_READ,NULL,CREATE_ALWAYS
						,FILE_ATTRIBUTE_NORMAL, NULL) ;

	radix = base_DEC_char ;					// toϊ̊DECi10jSET
	iStop_flg = 0 ;							// ~ر
	iRaed_cnt1 = 0 ;
	for (ii=0;ii< (int)INIFILE_NO;ii++)
	{

		iRet = ini_FileWrite_Section(ii) ;	// Section o 02.11.15 ADD
		if (iRet != 0)
		{
			return(iRet) ;
		}
		
		// ͯ-ُ̧o
		bRet = WriteFile(hIniFile, Ini_Head_in[ii].lpIniHead,(DWORD)Ini_Head_in[ii].iHead_lng
							,(LPDWORD)&dwBytesWrite2, NULL);
		if(bRet == FALSE) 
		{							// s
			dwEcode = GetLastError() ;
			bRet = CloseHandle(hIniFile);	
			return((int)dwEcode) ;
		}

		if (ii ==0)
		{
			lpdwData = (DWORD *)lpOutIniDataTbl[ii] ;
			dwWork = (DWORD)*lpdwData;
		}
		else
		{
			dwWork = (DWORD)*lpOutIniDataTbl[ii] ;
		}
		memset (&cInData_buf2[0], 0x20, 20);
		if (Ini_Head_in[ii].iMaxDataLng == 10)
		{
			_ltoa( dwWork, &cInData_buf2[0], radix);	// l->ϊ
			bRet = WriteFile(hIniFile, &cInData_buf2[0],(DWORD)8
							,(LPDWORD)&dwBytesWrite2, NULL);
			if(bRet == FALSE) 
			{							// s
				dwEcode = GetLastError() ;
				bRet = CloseHandle(hIniFile);	
				return((int)dwEcode) ;
			}
		}
		else if (Ini_Head_in[ii].iMaxDataLng == 6)
		{
			_itoa( dwWork, &cInData_buf2[0], radix);	// l->ϊ
			bRet = WriteFile(hIniFile, &cInData_buf2[0],(DWORD)4
							,(LPDWORD)&dwBytesWrite2, NULL);
			if(bRet == FALSE) 
			{							// s
				dwEcode = GetLastError() ;
				bRet = CloseHandle(hIniFile);	
				return((int)dwEcode) ;
			}
		}
		else
		{
			_itoa( dwWork, &cInData_buf2[0], radix);	// l->ϊ
			bRet = WriteFile(hIniFile, &cInData_buf2[0],(DWORD)2
							,(LPDWORD)&dwBytesWrite2, NULL);
			if(bRet == FALSE) 
			{							// s
				dwEcode = GetLastError() ;
				bRet = CloseHandle(hIniFile);	
				return((int)dwEcode) ;
			}
		}

		bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
		if(bRet == FALSE) 
		{							// s
			dwEcode = GetLastError() ;
			bRet = CloseHandle(hIniFile);	
			return((int)dwEcode) ;
		}


	}
	bRet = CloseHandle(hIniFile) ;


	return(iRet) ;
}


//**************************************************************************//
//	FUNCTION :	ini_FileWrite_Section  iniFile Sectionݏ			//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	iKind			| int			| I | ݎޔԍ						//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int ini_FileWrite_Section(int iKind) 
{

//----	int		iRet ;
	BOOL	bRet ;
	DWORD	dwEcode ;




	switch (iKind)
	{
		case READCODE_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szReadCodeSection[0],(DWORD)READCODE_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case CODE39_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szCode39Section[0],(DWORD)CODE39_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case NW7_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szNw7Section[0],(DWORD)NW7_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case WPCA_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szWpcaSection[0],(DWORD)WPCA_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case WPC_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szWpcSection[0],(DWORD)WPC_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case UPCA_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szUpcaSection[0],(DWORD)UPCA_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case UPC_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szUpcSection[0],(DWORD)UPC_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case IDF_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szIdfSection[0],(DWORD)IDF_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case ITF_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szItfSection[0],(DWORD)ITF_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case CODE93_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szCode93Section[0],(DWORD)CODE93_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case CODE128_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szCode128Section[0],(DWORD)CODE128_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case MSI_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szMsiSection[0],(DWORD)MSI_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case IATA_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szIataSection[0],(DWORD)IATA_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case READMODE_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szReadModeSection[0],(DWORD)READMODE_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case BUZZER_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szBuzzSection[0],(DWORD)BUZZER_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case LED_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szLedSection[0],(DWORD)LED_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case OUTBUFF_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szOutBuffSection[0],(DWORD)OUTBUFF_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case ENDCODE_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szEndModeCtrlSection[0],(DWORD)ENDCODE_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case READCTRLMODE_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szReadCtrlSection[0],(DWORD)READCTRLMODE_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case READCNT_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szReadCntSection[0],(DWORD)READCNT_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case CMPCNT_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szCmpCntSection[0],(DWORD)CMPCNT_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		case SCANTIME_SECTION :
		// ͯ-ُ̧o
			bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
			bRet = WriteFile(hIniFile, &szScanTimeSection[0],(DWORD)SCANTIME_SECTION_LNG
							,(LPDWORD)&dwBytesWrite2, NULL);
			break ;
		default:
			return(0) ;
			break ;
	}


	if(bRet == FALSE) 
	{							// s
		dwEcode = GetLastError() ;
		bRet = CloseHandle(hIniFile);	
		return((int)dwEcode) ;
	}
	bRet = WriteFile(hIniFile, &szCrChar[0],(DWORD)2,(LPDWORD)&dwBytesWrite2, NULL);
	if(bRet == FALSE) 
	{							// s
		dwEcode = GetLastError() ;
		bRet = CloseHandle(hIniFile);	
		return((int)dwEcode) ;
	}



	return(0) ;
}

//**************************************************************************//
//	FUNCTION :	oemCreateDirectory  ިڸ؍쐬							//
//																			//
//--Variables---------------------------------------------------------------//
//		ϐ		|		^		|I/O|								//
//--------------------------------------------------------------------------//
//	PathName		| TCHAR *		| I | ިڸ߽߲				//
//					| 				| 	| 									//
//					| 				| 	| 									//
//**************************************************************************//
int oemCreateDirectory(TCHAR *PathName)
{
	int		i;
	TCHAR	buf[MAX_PATHNAMESIZE+1];
	



	ZeroMemory(buf, sizeof(buf));
	for(i=0; i<(int)wcslen(PathName); i++){
		if(PathName[i] == TEXT('\\')){
			CreateDirectory(buf, NULL);
		}
		buf[i] = PathName[i];
	}


	return 0;
}




