#include <windows.h>				// 
#include <winbase.h>				// 
#include <stdlib.h>	
#include "resource.h"
#include "Set1D_def.h"
#include "OBRREQ.h"
#include <commctrl.h>
#include <prsht.h>                   // vpeB V[g̃CN[h

#define MAX_LOADSTRING 100

// Global Variables:

int	radix ;



extern HINSTANCE			hInst;			// The current instance
extern HWND				hwndCB;			// The command bar handle

// Code Setting
extern int	gnowCode;
extern int	gnowCodeCheckDigit ;
extern int	gnowCodeOutFormat ;
extern int	gnowCodeReadMode ; 
extern int	gnowCodeBuzzer ;
extern int	gnowCodeLed ;
extern int	gnowCodeOutBuff ;
extern int	gnowCodeEndCode ;
extern int	gnowCodeReadActMode ;
extern int	gnowFilterMode ;						// 02.12.20 ADD



extern struct CODEPARAM	cparam[NUM_SYMBOLOGIES];	// Code Parameter
extern struct CODEONOFF	codeonoff[NUM_SYMBOLOGIES];	// Code Enable/Disble

// Code Range / min digit / max digit
extern const int iMin[NUM_SYMBOLOGIES] ;
extern const int iMax[NUM_SYMBOLOGIES] ;

extern const int iMinOnOff[NUM_SYMBOLOGIES] ;
extern const int iMaxOnOff[NUM_SYMBOLOGIES] ;
extern const int iOutFormatOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitOnOff[NUM_SYMBOLOGIES] ;
extern const int iCheckCharOnOff[NUM_SYMBOLOGIES] ;



// R[h̎
extern const TCHAR CodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CmbOrder[NUM_SYMBOLOGIES] ;
extern int Order1D[14] ;

extern const int iOutFormatSize[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE39̎
extern const TCHAR OutFomatCd39List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd39Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT NW7̎
extern const TCHAR OutFomatNw7List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatNw7Order[NUM_SYMBOLOGIES] ;
// OUTFORMAT CODE128̎
extern const TCHAR OutFomatCd128List[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutFomatCd128Order[NUM_SYMBOLOGIES] ;
extern const int iCheckDigitSize[NUM_SYMBOLOGIES] ;
// Check Digit MSI̎
extern const TCHAR CheckDigitMsiList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitMsiOrder[NUM_SYMBOLOGIES] ;
// Check Digit IATA̎
extern const TCHAR CheckDigitIataList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitIataOrder[NUM_SYMBOLOGIES] ;
// Check Digit ̑̎
extern const TCHAR CheckDigitAnyList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int CheckDigitAnyOrder[NUM_SYMBOLOGIES] ;
// ǂݎ胂[h ̎
extern const TCHAR ReadModeList[NUM_SYMBOL_RDMODE][32] ;
// Combobox Order
extern int ReadModeOrder[NUM_SYMBOL_RDMODE] ;
// uU[ ̎
extern const TCHAR BuzzerList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int BuzzerOrder[NUM_SYMBOLOGIES] ;
// kdc ̎
extern const TCHAR LedList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int LedOrder[NUM_SYMBOLOGIES] ;
// o̓obt@ ̎
extern const TCHAR OutBuffList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int OutBuffOrder[NUM_SYMBOLOGIES] ;
// ǂݎ蓮샂[h ̎
extern const TCHAR ReadActModeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int ReadActModeOrder[NUM_SYMBOLOGIES] ;
// IR[h ̎
extern const TCHAR EndCodeList[NUM_SYMBOLOGIES][32] ;
// Combobox Order
extern int EndCodeOrder[NUM_SYMBOLOGIES] ;

// tB^[h ̎ 02.12.20 ADD
extern const TCHAR FilterModeList[NUM_SYMBOLOGIES][32];
extern int FilterModeOrder[NUM_SYMBOLOGIES] ;


extern int	giCodeTbl[NUM_SYMBOLOGIES] ;			// 02.11.28 ADD

extern const	struct	m_tbl	ObrModeTblDef ;
extern struct	m_tbl	ObrModeTbl ;

extern	TCHAR	szEndsts[20] ;
extern	TCHAR	ucLength[40] ;


void TST_GetCodests(void);				// CODEL/ݒ擾
int	TST_SetIni(HWND hWnd) ;					// 
int	TST_SetCodeOptinGet(HWND) ;		// 
void TST_GetCodeOption(void) ;			// CODEIvVL/ݒ擾
void ModeSetIniDsp(HWND) ;					// Mode Settings \
void ModeSetGetData(HWND) ;					// Mode Settings GET
int	CheckRangeCodeConfig(HWND, int) ;
void ShowParamCodeConfig(HWND, int, int) ;
void ModeData_Set(HWND) ;
void TST_GetCodests2(int) ;				// 02.11.28 ADD



//===========================================================================
// Check Data Range Parameter
int	CheckRangeCodeConfig(HWND hDlg, int nowCode)
{
	int tmin, tmax;

	tmin = (int)SendDlgItemMessage( hDlg, IDC_SPIN_EMIN, UDM_GETPOS, 0, 0);
	tmax = (int)SendDlgItemMessage( hDlg, IDC_SPIN_EMAX, UDM_GETPOS, 0, 0);

	if( iMin[nowCode] > tmin || tmax > iMax[nowCode] ||	tmin > tmax ){
		MessageBox(hDlg, TEXT("Invalid Data Range"), TEXT("Parameter Error"), MB_OK);
		cparam[nowCode].bp[MINOP]=iMin[nowCode];
		cparam[nowCode].bp[MAXOP]=iMax[nowCode];
		ShowParamCodeConfig(hDlg, nowCode, nowCode);
		SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, nowCode, 0); // remain position
		return 1;
	}
	return 0;
}

// Show Current Parameter Dialog
void ShowParamCodeConfig(HWND hDlg, int preCode, int nowCode)
{
	int		ii,j=0, sa, ishow,iPos;
	HWND	hTemp;


	// Show of Hide Limit Data Range
	sa = iMinOnOff[nowCode];
	if(sa==0)
	{
		ishow	= SW_HIDE;
	}
	else
	{
		ishow	= SW_SHOW;
	}
	hTemp	= GetDlgItem(hDlg, IDC_EMIN);
	ShowWindow(hTemp, ishow);
	sa = iMaxOnOff[nowCode];
		if(sa==0)
	{
		ishow	= SW_HIDE;
	}
	else
	{
		ishow	= SW_SHOW;
	}
	hTemp	= GetDlgItem(hDlg, IDC_EMAX);
	ShowWindow(hTemp, ishow);

	// Limit Data Range
	SendDlgItemMessage(hDlg, IDC_SPIN_EMIN, UDM_SETRANGE, 0, MAKELONG((short)iMax[nowCode], (short)iMin[nowCode]));
	SendDlgItemMessage(hDlg, IDC_SPIN_EMAX, UDM_SETRANGE, 0, MAKELONG((short)iMax[nowCode], (short)iMin[nowCode]));


	if (cparam[nowCode].bp[CHECKCHAROP] == OBR_CHKCON)
	{
		SendDlgItemMessage (hDlg, IDC_CHECK_CHECKCH, BM_SETCHECK, BST_CHECKED, 0);
	}
	else
	{
		SendDlgItemMessage (hDlg, IDC_CHECK_CHECKCH, BM_SETCHECK, BST_UNCHECKED, 0);
	}

	// Show or Hide Check Box
	sa = iCheckCharOnOff[nowCode];
	if(sa==0)
	{
		ishow	= SW_HIDE;
	}
	else
	{
		ishow	= SW_SHOW;
	}
	hTemp	= GetDlgItem(hDlg, IDC_CHECK_CHECKCH);
	ShowWindow(hTemp, ishow);

	SendDlgItemMessage(	hDlg, IDC_CHECK_ENABLE, BM_SETCHECK, codeonoff[nowCode].be, 0);
	SendDlgItemMessage(	hDlg, IDC_SPIN_EMIN, UDM_SETPOS, 0, cparam[nowCode].bp[MINOP]);
	SendDlgItemMessage(	hDlg, IDC_SPIN_EMAX, UDM_SETPOS, 0, cparam[nowCode].bp[MAXOP]);
														// OUT FORMAT SET

	// Show or Hide Check Box
	sa = iOutFormatOnOff[nowCode];
	if(sa==0)
	{
		ishow	= SW_HIDE;
	}
	else
	{
		ishow	= SW_SHOW;
	}
	hTemp	= GetDlgItem(hDlg, IDC_COMBO_OUTFORMAT);
	ShowWindow(hTemp, ishow);



	SendDlgItemMessage(hDlg, IDC_COMBO_OUTFORMAT, CB_RESETCONTENT, 0, 0);
	iPos = cparam[gnowCode].bp[OUTFORMATOP] ;
	if(nowCode == OBR_CODE_CD128)
	{
		for (ii=0;ii<5;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTFORMAT, CB_ADDSTRING, 0
										, (LPARAM)OutFomatCd128List[ii]);
		}
		if (cparam[gnowCode].bp[OUTFORMATOP] == SYM_CODE128AIM)
		{
			iPos = 3 ;
		}
		else if (cparam[gnowCode].bp[OUTFORMATOP] == SYM_CODE128AIM)
		{
			iPos = 4 ;
		}
	}
	else if(nowCode == OBR_CODE_CD39)
	{
		for (ii=0;ii<4;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTFORMAT, CB_ADDSTRING, 0
										, (LPARAM)OutFomatCd39List[ii]);
		}
	}
	else if(nowCode == OBR_CODE_NW7)
	{
		for (ii=0;ii<2;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_OUTFORMAT, CB_ADDSTRING, 0
										, (LPARAM)OutFomatNw7List[ii]);
		}
	}

	SendDlgItemMessage(	hDlg, IDC_COMBO_OUTFORMAT, CB_SETCURSEL, iPos, 0);

	// Show or Hide Check Box
	sa = iCheckDigitOnOff[nowCode];
	if(sa==0)
	{
		ishow	= SW_HIDE;
	}
	else
	{
		ishow	= SW_SHOW;
	}
	hTemp	= GetDlgItem(hDlg, IDC_COMBO_CHECKDIGIT);
	ShowWindow(hTemp, ishow);
	SendDlgItemMessage(hDlg, IDC_COMBO_CHECKDIGIT, CB_RESETCONTENT, 0, 0);
	if (nowCode == OBR_CODE_MSI)
	{
		for (ii=0;ii<4;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_CHECKDIGIT, CB_ADDSTRING, 0, (LPARAM)CheckDigitMsiList[ii]);
		}
	}
	else if (nowCode == OBR_CODE_IATA)
	{
		for (ii=0;ii<4;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_CHECKDIGIT, CB_ADDSTRING, 0, (LPARAM)CheckDigitIataList[ii]);
		}
	}
	else
	{
		for (ii=0;ii<2;ii++)
		{
			SendDlgItemMessage(hDlg, IDC_COMBO_CHECKDIGIT, CB_ADDSTRING, 0, (LPARAM)CheckDigitAnyList[ii]);
		}
	}
	SendDlgItemMessage(	hDlg, IDC_COMBO_CHECKDIGIT, CB_SETCURSEL, cparam[gnowCode].bp[CHECKDIGITOP],0 );


}


//==========================================================================
//
//
void ModeSetIniDsp(HWND hDlg)
{
	
	int	i,iPos ;
	LPTSTR	szRet ;

	for (i=0; i<2; i++){
		SendDlgItemMessage(hDlg, (int)IDC_COMBO_MODETYPE,(UINT)CB_ADDSTRING, 0
							, (LPARAM)ReadModeList[ReadModeOrder[i]]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_MODETYPE,(UINT)WM_SETTEXT, 0,(LPARAM)ReadModeList[ObrModeTbl.Type]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_MODETYPE,(UINT)CB_SETCURSEL, ObrModeTbl.Type,0);
	for (i=0; i<2; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_BUZZ,(UINT)CB_ADDSTRING, 0
								, (LPARAM)BuzzerList[BuzzerOrder[i]]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_BUZZ,(UINT)WM_SETTEXT, 0,(LPARAM)BuzzerList[ObrModeTbl.Buzc]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_BUZZ,(UINT)CB_SETCURSEL, ObrModeTbl.Buzc,0);
	for (i=0; i<3; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_LED,(UINT)CB_ADDSTRING, 0
								, (LPARAM)LedList[LedOrder[i]]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_LED,(UINT)WM_SETTEXT, 0,(LPARAM)LedList[ObrModeTbl.Ledc]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_LED,(UINT)CB_SETCURSEL, ObrModeTbl.Ledc,0);
	for (i=0; i<3; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_OUTBUFF,(UINT)CB_ADDSTRING, 0
								, (LPARAM)OutBuffList[i]);
	}
	iPos = ObrModeTbl.Bufc ;
	if (iPos >= OBR_STOFF) iPos -= 1 ;
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_OUTBUFF,(UINT)WM_SETTEXT, 0,(LPARAM)OutBuffList[iPos]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_OUTBUFF,(UINT)CB_SETCURSEL, iPos,0);
	for (i=0; i<3; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_ENDCHAR,(UINT)CB_ADDSTRING, 0
								, (LPARAM)EndCodeList[EndCodeOrder[i]]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_ENDCHAR,(UINT)WM_SETTEXT, 0,(LPARAM)EndCodeList[ObrModeTbl.Endc]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_ENDCHAR,(UINT)CB_SETCURSEL, ObrModeTbl.Endc,0);
	for (i=0; i<2; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_MODEACT,(UINT)CB_ADDSTRING, 0
								, (LPARAM)ReadActModeList[ReadActModeOrder[i]]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_MODEACT,(UINT)WM_SETTEXT, 0,(LPARAM)ReadActModeList[ObrModeTbl.Mode]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_MODEACT,(UINT)CB_SETCURSEL, ObrModeTbl.Mode,0);
	

//====== 02.12.20 ADD ============================================================================
	for (i=0; i<4; i++){
		SendDlgItemMessage(hDlg,(int)IDC_COMBO_FILTERMODE,(UINT)CB_ADDSTRING, 0
								, (LPARAM)FilterModeList[i]);
	}
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_FILTERMODE,(UINT)WM_SETTEXT, 0
								,(LPARAM)FilterModeList[ObrModeTbl.dwFilterMode]);
	SendDlgItemMessage (hDlg,(int)IDC_COMBO_FILTERMODE,(UINT)CB_SETCURSEL
							,ObrModeTbl.dwFilterMode,0);
//=================================================================================================

	// Limit Data Range
	SendDlgItemMessage(hDlg,(int)IDC_SPIN_CHECKCNT,(UINT)UDM_SETRANGE, 0, MAKELONG((short)9, (short)1));
	SendDlgItemMessage(hDlg,(int)IDC_SPIN_READCNT,(UINT)UDM_SETRANGE, 0, MAKELONG((short)9, (short)1));
	SendDlgItemMessage(hDlg,(int)IDC_SPIN_SCANTIME,(UINT)UDM_SETRANGE, 0, MAKELONG((short)9, (short)1));
//==== 03.01.16 ADD START ================================================================================
	SendDlgItemMessage(hDlg,(int)IDC_SPIN_FILTERTIME,(UINT)UDM_SETRANGE, 0, MAKELONG((short)8, (short)1));
//========================================================================================================


// ƍ񐔁@\
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.cmp_ct,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_CHECKCNT,(LPCTSTR)&szEndsts[0]);

// ǎ񐔁@\
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.rd_ct,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_READCNT,(LPCTSTR)&szEndsts[0]);

// XL^C}@\
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.scn_tm,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_SCANTIME,(LPCTSTR)&szEndsts[0]);

//=== 03.01.16 ADD START ==================================================================
// tB^nm^C}@\
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.dwFilterCnt,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_FILTERTIME,(LPCTSTR)&szEndsts[0]);
//===========================================================================================




	return ;
}

//==========================================================================
//
//
void ModeSetGetData(HWND hDlg)
{
	
	int	iRet2 ;
	


	gnowCodeReadMode = ReadModeOrder[SendDlgItemMessage(hDlg,IDC_COMBO_MODETYPE, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.Type = (BYTE)gnowCodeReadMode ;
	gnowCodeBuzzer = BuzzerOrder[SendDlgItemMessage(hDlg,IDC_COMBO_BUZZ, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.Buzc = (BYTE)gnowCodeBuzzer ;
	gnowCodeLed = LedOrder[SendDlgItemMessage(hDlg,IDC_COMBO_LED, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.Ledc = (BYTE)gnowCodeLed ;
	gnowCodeOutBuff = OutBuffOrder[SendDlgItemMessage(hDlg,IDC_COMBO_OUTBUFF, CB_GETCURSEL, 0, 0) ];
	if (gnowCodeOutBuff > 0) gnowCodeOutBuff += 1 ;
	ObrModeTbl.Bufc = (BYTE)gnowCodeOutBuff ;
	gnowCodeEndCode = EndCodeOrder[SendDlgItemMessage(hDlg,IDC_COMBO_ENDCHAR, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.Endc = (BYTE)gnowCodeEndCode ;
	gnowCodeReadActMode = ReadActModeOrder[SendDlgItemMessage(hDlg,IDC_COMBO_MODEACT, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.Mode = (BYTE)gnowCodeReadActMode ;

//=== 02.12.20 ADD ===================================================================================
	gnowFilterMode = FilterModeOrder[SendDlgItemMessage(hDlg,IDC_COMBO_FILTERMODE, CB_GETCURSEL, 0, 0) ];
	ObrModeTbl.dwFilterMode = (BYTE)gnowFilterMode ;
//====================================================================================================



// ƍ񐔁@SET
	GetDlgItemText(hDlg,IDC_EDIT_CHECKCNT,&ucLength[0],8);
	iRet2 = _wtoi(&ucLength[0]) ;				// Ch^ϊ
	ObrModeTbl.cmp_ct = (int)iRet2 ;		

// ǎ񐔁@SET
	GetDlgItemText(hDlg,IDC_EDIT_READCNT,&ucLength[0],8);
	iRet2 = _wtoi(&ucLength[0]) ;				// Ch^ϊ
	ObrModeTbl.rd_ct = (int)iRet2 ;		
	
// XL^C}@SET
	GetDlgItemText(hDlg,IDC_EDIT_SCANTIME,&ucLength[0],8);
	iRet2 = _wtoi(&ucLength[0]) ;				// Ch^ϊ
	ObrModeTbl.scn_tm = (int)iRet2 ;		

//=== 03.01.16 ADD START ==================================================================
// tB^nm^C}@SET
	GetDlgItemText(hDlg,IDC_EDIT_FILTERTIME,&ucLength[0],8);
	iRet2 = _wtoi(&ucLength[0]) ;				// Ch^ϊ
	ObrModeTbl.dwFilterCnt = (DWORD)iRet2 ;		
//===========================================================================================

	return ;
}

//==========================================================================
//
//
void ModeData_Set(HWND hDlg)
{
	
	int	iPos ;
	LPTSTR	szRet ;
	


	gnowCodeReadMode = ObrModeTbl.Type ;

	gnowCodeBuzzer = ObrModeTbl.Buzc ;
	gnowCodeLed = ObrModeTbl.Ledc ;
	gnowCodeOutBuff = ObrModeTbl.Bufc ;
	gnowCodeEndCode = ObrModeTbl.Endc;
	gnowCodeReadActMode = ObrModeTbl.Mode ;
	gnowFilterMode = ObrModeTbl.dwFilterMode ;			// 02.12.20 ADD

//=== 02.12.20 ADD ============================================================================
	gnowFilterMode = ObrModeTbl.dwFilterMode;
//=============================================================================================
	iPos = ObrModeTbl.Bufc ;
	if (iPos >= OBR_STOFF) iPos -= 1 ;

	SendDlgItemMessage (hDlg, (int)IDC_COMBO_MODETYPE,(UINT)WM_SETTEXT, 0,(LPARAM)ReadModeList[ObrModeTbl.Type]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_MODETYPE,(UINT)CB_SETCURSEL, ObrModeTbl.Type,0);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_BUZZ,(UINT)WM_SETTEXT, 0,(LPARAM)BuzzerList[ObrModeTbl.Buzc]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_BUZZ,(UINT)CB_SETCURSEL, ObrModeTbl.Buzc,0);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_LED,(UINT)WM_SETTEXT, 0,(LPARAM)LedList[ObrModeTbl.Ledc]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_LED,(UINT)CB_SETCURSEL, ObrModeTbl.Ledc,0);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_OUTBUFF,(UINT)WM_SETTEXT, 0,(LPARAM)OutBuffList[iPos]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_OUTBUFF,(UINT)CB_SETCURSEL, iPos,0);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_ENDCHAR,(UINT)WM_SETTEXT, 0,(LPARAM)EndCodeList[ObrModeTbl.Endc]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_ENDCHAR,(UINT)CB_SETCURSEL, ObrModeTbl.Endc,0);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_MODEACT,(UINT)WM_SETTEXT, 0,(LPARAM)ReadActModeList[ObrModeTbl.Mode]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_MODEACT,(UINT)CB_SETCURSEL, ObrModeTbl.Mode,0);

//==== 02.12.20 ADD =====================================================================
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_FILTERMODE,(UINT)WM_SETTEXT, 0,(LPARAM)FilterModeList[ObrModeTbl.dwFilterMode]);
	SendDlgItemMessage (hDlg, (int)IDC_COMBO_FILTERMODE,(UINT)CB_SETCURSEL, ObrModeTbl.dwFilterMode,0);


// ƍ񐔁@SET

	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.cmp_ct,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_CHECKCNT,(LPCTSTR)&szEndsts[0]);

// ǎ񐔁@SET
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.rd_ct,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_READCNT,(LPCTSTR)&szEndsts[0]);

// XL^C}@SET
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.scn_tm,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_SCANTIME,(LPCTSTR)&szEndsts[0]);

//=== 03.01.16 ADD START ==================================================================
// tB^nm^C}@\
	radix = base_DEC_char ;						// DECi10ijɂ
	szRet = _itow((int)ObrModeTbl.dwFilterCnt,&szEndsts[0],radix) ;
	SetDlgItemText(hDlg,IDC_EDIT_FILTERTIME,(LPCTSTR)&szEndsts[0]);
//===========================================================================================


	return ;
}


//===========================================================================
//	TST_GetCodests		CODEL/ݒ擾
//
void	TST_GetCodests(void) 
{

	int	ii ;

	if (cparam[OBR_CODE_CD39].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_CD39 ;			// CODE39LSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_CD39) ;		// CODE39SET
	}
	if (cparam[OBR_CODE_NW7].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_NW_7 ;			// NW7LSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_NW_7) ;		// NW7SET
	}
	if (cparam[OBR_CODE_WPCA].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_WPCA ;			// WPCALSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_WPCA) ;		// WPCASET
	}
	if (cparam[OBR_CODE_WPC].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_WPC ;			// WPCLSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_WPC) ;			// WPCSET
	}
	if (cparam[OBR_CODE_UPCA].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_UPCA ;			// UPCALSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_UPCA) ;		// UPCASET
	}
	if (cparam[OBR_CODE_UPC].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_UPC ;			// UPCLSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_UPC) ;			// UPCSET
	}
	if (cparam[OBR_CODE_IDF].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_IDF ;			// IDFLSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_IDF) ;			// IDFSET
	}
	if (cparam[OBR_CODE_ITF].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_ITF ;			// ITFLSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_ITF) ;			// ITFSET
	}
	if (cparam[OBR_CODE_CD93].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_CD93 ;			// CD93LSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_CD93) ;		// CD93SET
	}
	if (cparam[OBR_CODE_CD128].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_CD128 ;			// CD128LSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_CD128) ;		// CD128SET
	}
	if (cparam[OBR_CODE_MSI].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_MSI ;			// MSILSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_MSI) ;			// MSISET
	}
	if (cparam[OBR_CODE_IATA].be == TRUE)
	{
		ObrModeTbl.Code |= OBR_IATA ;			// IATALSET
	}
	else
	{
		ObrModeTbl.Code &= (~OBR_IATA) ;		// IATASET
	}
	
	
	for (ii=0;ii<NUM_SYMBOLOGIES;ii++)
	{
		if (cparam[ii].be == FALSE)
		{
			codeonoff[ii].be = BST_UNCHECKED ;
		}
		else
		{
			codeonoff[ii].be = BST_CHECKED ;
		}
		
	}


	return ;
}



//===========================================================================
//	TST_GetCodests2		CODEL/ݒ 02.11.28 ADD
//
void	TST_GetCodests2(int nowCode) 
{


	if (cparam[nowCode].be == TRUE)
	{
		ObrModeTbl.Code |= giCodeTbl[nowCode] ;
	}
	else
	{
		ObrModeTbl.Code &= (~giCodeTbl[nowCode]) ;		// CODE39SET
	}

	return ;
}




//===========================================================================
//	TST_GetCodeOption	-	CODEIvVL/ݒ擾
//
void	TST_GetCodeOption(void) 
{

	int	ii ;



	for (ii=1;ii<CODEOPTION_SIZE;ii++)
	{
		ObrModeTbl.Cd39[ii]  = cparam[OBR_CODE_CD39].bp[ii] ;
		ObrModeTbl.Nw7[ii]   = cparam[OBR_CODE_NW7].bp[ii] ;
		ObrModeTbl.Wpcea[ii] = cparam[OBR_CODE_WPCA].bp[ii] ;
		ObrModeTbl.Wpce[ii]  = cparam[OBR_CODE_WPC].bp[ii] ;
		ObrModeTbl.Upcea[ii] = cparam[OBR_CODE_UPCA].bp[ii] ;
		ObrModeTbl.Upce[ii]  = cparam[OBR_CODE_UPC].bp[ii] ;
		ObrModeTbl.Idsf[ii]  = cparam[OBR_CODE_IDF].bp[ii] ;
		ObrModeTbl.Itrf[ii]  = cparam[OBR_CODE_ITF].bp[ii] ;
		ObrModeTbl.Cd93[ii]  = cparam[OBR_CODE_CD93].bp[ii] ;
		ObrModeTbl.Cd128[ii] = cparam[OBR_CODE_CD128].bp[ii] ;
		ObrModeTbl.Msi[ii]   = cparam[OBR_CODE_MSI].bp[ii] ;
		ObrModeTbl.Iata[ii]  = cparam[OBR_CODE_IATA].bp[ii] ;
	}
	if (ObrModeTbl.Cd128[3] == SYM_CODE128AIM)
				ObrModeTbl.Cd128[3] = OBR_128AIM ;
	else if (ObrModeTbl.Cd128[3] == SYM_CODE128FNC)
				ObrModeTbl.Cd128[3] = OBR_128FNC ;


	return ;
}




//===========================================================================
//	TST_SetIni	-	샂[hݒ vV[W
//
int	TST_SetIni(HWND hWnd) 
{

	int	iRet,ii ;


	iRet = 0 ;
	


	if(ObrModeTbl.Code & OBR_CD39)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE39, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_CD39].be = TRUE ;
		codeonoff[OBR_CODE_CD39].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE39, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_CD39].be = FALSE ;
		codeonoff[OBR_CODE_CD39].be = BST_UNCHECKED ;

	}

/************************************/
/* mvV	          				*/
/************************************/
	if(ObrModeTbl.Code & OBR_NW_7)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_NW7, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_NW7].be = TRUE ;
		codeonoff[OBR_CODE_NW7].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_NW7, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_NW7].be = FALSE ;
		codeonoff[OBR_CODE_NW7].be = BST_UNCHECKED ;

	}

/************************************/
/* vob	`				*/
/************************************/
	if(ObrModeTbl.Code & OBR_WPCA)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_WPCA, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_WPCA].be = TRUE ;
		codeonoff[OBR_CODE_WPCA].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_WPCA, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_WPCA].be = FALSE ;
		codeonoff[OBR_CODE_WPCA].be = BST_UNCHECKED ;

	}

/************************************/
/* vob							*/
/************************************/
	if(ObrModeTbl.Code & OBR_WPC)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_WPC, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_WPC].be = TRUE ;
		codeonoff[OBR_CODE_WPC].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_WPC, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_WPC].be = FALSE ;
		codeonoff[OBR_CODE_WPC].be = BST_UNCHECKED ;
	}

/************************************/
/* tob|d	`			*/
/************************************/
	if(ObrModeTbl.Code & OBR_UPCA)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_UPCA, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_UPCA].be = TRUE ;
		codeonoff[OBR_CODE_UPCA].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_UPCA, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_UPCA].be = FALSE ;
		codeonoff[OBR_CODE_UPCA].be = BST_UNCHECKED ;

	}

/************************************/
/* tob|d						*/
/************************************/
	if(ObrModeTbl.Code & OBR_UPC)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_UPC, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_UPC].be = TRUE ;
		codeonoff[OBR_CODE_UPC].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_UPC, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_UPC].be = FALSE ;
		codeonoff[OBR_CODE_UPC].be = BST_UNCHECKED ;

	}

/************************************/
/* hQT		*/
/************************************/
	if(ObrModeTbl.Code & OBR_IDF)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_IDF, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_IDF].be = TRUE ;
		codeonoff[OBR_CODE_IDF].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_IDF, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_IDF].be = FALSE ;
		codeonoff[OBR_CODE_IDF].be = BST_UNCHECKED ;

	}

/************************************/
/* hQT	*/
/************************************/
	if(ObrModeTbl.Code & OBR_ITF)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_ITF, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_ITF].be = TRUE ;
		codeonoff[OBR_CODE_ITF].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_ITF, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_ITF].be = FALSE ;
		codeonoff[OBR_CODE_ITF].be = BST_UNCHECKED ;


	}

/****************************/
/* bncd|XR			*/
/****************************/
	if(ObrModeTbl.Code & OBR_CD93)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE93, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_CD93].be = TRUE ;
		codeonoff[OBR_CODE_CD93].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE93, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_CD93].be = FALSE ;
		codeonoff[OBR_CODE_CD93].be = BST_UNCHECKED ;

	}

/****************************/
/* bncd|PQW			*/
/****************************/
	if(ObrModeTbl.Code & OBR_CD128)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE128, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_CD128].be = TRUE ;
		codeonoff[OBR_CODE_CD128].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_CODE128, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_CD128].be = FALSE ;
		codeonoff[OBR_CODE_CD128].be = BST_UNCHECKED ;


	}

/****************************/
/* lrh					*/
/****************************/
	if(ObrModeTbl.Code & OBR_MSI)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_MSI, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_MSI].be = TRUE ;
		codeonoff[OBR_CODE_MSI].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_MSI, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_MSI].be = FALSE ;
		codeonoff[OBR_CODE_MSI].be = BST_UNCHECKED ;


	}

/****************************/
/* h`s`					*/
/****************************/
	if(ObrModeTbl.Code & OBR_IATA)
	{
								// ޯON
		SendDlgItemMessage (hWnd, IDC_CHECK_IATA, BM_SETCHECK, BST_CHECKED, 0);
		cparam[OBR_CODE_IATA].be = TRUE ;
		codeonoff[OBR_CODE_IATA].be = BST_CHECKED ;
	}
	else
	{
								// ޯOFF
		SendDlgItemMessage (hWnd, IDC_CHECK_IATA, BM_SETCHECK, BST_UNCHECKED, 0);
		cparam[OBR_CODE_IATA].be = FALSE ;
		codeonoff[OBR_CODE_IATA].be = BST_UNCHECKED ;
	}


	for (ii=1;ii<CODEOPTION_SIZE;ii++)
	{
		cparam[OBR_CODE_CD39].bp[ii] = ObrModeTbl.Cd39[ii] ;
		cparam[OBR_CODE_NW7].bp[ii] = ObrModeTbl.Nw7[ii] ;
		cparam[OBR_CODE_WPCA].bp[ii] = ObrModeTbl.Wpcea[ii] ;
		cparam[OBR_CODE_WPC].bp[ii] = ObrModeTbl.Wpce[ii] ;
		cparam[OBR_CODE_UPCA].bp[ii] = ObrModeTbl.Upcea[ii] ;
		cparam[OBR_CODE_UPC].bp[ii] = ObrModeTbl.Upce[ii] ;
		cparam[OBR_CODE_IDF].bp[ii] = ObrModeTbl.Idsf[ii] ;
		cparam[OBR_CODE_ITF].bp[ii] = ObrModeTbl.Itrf[ii] ;
		cparam[OBR_CODE_CD93].bp[ii] = ObrModeTbl.Cd93[ii] ;
		cparam[OBR_CODE_CD128].bp[ii] = ObrModeTbl.Cd128[ii] ;
		cparam[OBR_CODE_MSI].bp[ii] = ObrModeTbl.Msi[ii] ;
		cparam[OBR_CODE_IATA].bp[ii] = ObrModeTbl.Iata[ii] ;
	}

	if (cparam[OBR_CODE_CD128].bp[OUTFORMATOP] == OBR_128AIM)
				cparam[OBR_CODE_CD128].bp[OUTFORMATOP] = SYM_CODE128AIM ;
	else if (cparam[OBR_CODE_CD128].bp[OUTFORMATOP] == OBR_128FNC)
				cparam[OBR_CODE_CD128].bp[OUTFORMATOP] = SYM_CODE128FNC ;



	return(iRet) ;
}



//===========================================================================
//	TST_SetCodeOptinGet	-	bIvVGET vV[W
//
int	TST_SetCodeOptinGet(HWND hWnd) 
{

	int	iRet,ii ;

	iRet = 0 ;

	if(ObrModeTbl.Code & OBR_CD39)
	{
		cparam[OBR_CODE_CD39].be = TRUE ;
		codeonoff[OBR_CODE_CD39].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_CD39].be = FALSE ;
		codeonoff[OBR_CODE_CD39].be = BST_UNCHECKED ;

	}

/************************************/
/* mvV	          				*/
/************************************/
	if(ObrModeTbl.Code & OBR_NW_7)
	{
		cparam[OBR_CODE_NW7].be = TRUE ;
		codeonoff[OBR_CODE_NW7].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_NW7].be = FALSE ;
		codeonoff[OBR_CODE_NW7].be = BST_UNCHECKED ;

	}

/************************************/
/* vob	`				*/
/************************************/
	if(ObrModeTbl.Code & OBR_WPCA)
	{
		cparam[OBR_CODE_WPCA].be = TRUE ;
		codeonoff[OBR_CODE_WPCA].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_WPCA].be = FALSE ;
		codeonoff[OBR_CODE_WPCA].be = BST_UNCHECKED ;

	}

/************************************/
/* vob							*/
/************************************/
	if(ObrModeTbl.Code & OBR_WPC)
	{
		cparam[OBR_CODE_WPC].be = TRUE ;
		codeonoff[OBR_CODE_WPC].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_WPC].be = FALSE ;
		codeonoff[OBR_CODE_WPC].be = BST_UNCHECKED ;

	}

/************************************/
/* tob|d	`			*/
/************************************/
	if(ObrModeTbl.Code & OBR_UPCA)
	{
		cparam[OBR_CODE_UPCA].be = TRUE ;
		codeonoff[OBR_CODE_UPCA].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_UPCA].be = FALSE ;
		codeonoff[OBR_CODE_UPCA].be = BST_UNCHECKED ;

	}

/************************************/
/* tob|d						*/
/************************************/
	if(ObrModeTbl.Code & OBR_UPC)
	{
		cparam[OBR_CODE_UPC].be = TRUE ;
		codeonoff[OBR_CODE_UPC].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_UPC].be = FALSE ;
		codeonoff[OBR_CODE_UPC].be = BST_UNCHECKED ;

	}

/************************************/
/* hQT		*/
/************************************/
	if(ObrModeTbl.Code & OBR_IDF)
	{
		cparam[OBR_CODE_IDF].be = TRUE ;
		codeonoff[OBR_CODE_IDF].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_IDF].be = FALSE ;
		codeonoff[OBR_CODE_IDF].be = BST_UNCHECKED ;

	}

/************************************/
/* hQT	*/
/************************************/
	if(ObrModeTbl.Code & OBR_ITF)
	{
		cparam[OBR_CODE_ITF].be = TRUE ;
		codeonoff[OBR_CODE_ITF].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_ITF].be = FALSE ;
		codeonoff[OBR_CODE_ITF].be = BST_UNCHECKED ;

	}

/****************************/
/* bncd|XR			*/
/****************************/
	if(ObrModeTbl.Code & OBR_CD93)
	{
		cparam[OBR_CODE_CD93].be = TRUE ;
		codeonoff[OBR_CODE_CD93].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_CD93].be = FALSE ;
		codeonoff[OBR_CODE_CD93].be = BST_UNCHECKED ;

	}

/****************************/
/* bncd|PQW			*/
/****************************/
	if(ObrModeTbl.Code & OBR_CD128)
	{
		cparam[OBR_CODE_CD128].be = TRUE ;
		codeonoff[OBR_CODE_CD128].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_CD128].be = FALSE ;
		codeonoff[OBR_CODE_CD128].be = BST_UNCHECKED ;
	}

/****************************/
/* lrh					*/
/****************************/
	if(ObrModeTbl.Code & OBR_MSI)
	{
		cparam[OBR_CODE_MSI].be = TRUE ;
		codeonoff[OBR_CODE_MSI].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_MSI].be = FALSE ;
		codeonoff[OBR_CODE_MSI].be = BST_UNCHECKED ;
	}

/****************************/
/* h`s`					*/
/****************************/
	if(ObrModeTbl.Code & OBR_IATA)
	{
		cparam[OBR_CODE_IATA].be = TRUE ;
		codeonoff[OBR_CODE_IATA].be = BST_CHECKED ;
	}
	else
	{
		cparam[OBR_CODE_IATA].be = FALSE ;
		codeonoff[OBR_CODE_IATA].be = BST_UNCHECKED ;
	}


	for (ii=1;ii<CODEOPTION_SIZE;ii++)
	{
		cparam[OBR_CODE_CD39].bp[ii] = ObrModeTbl.Cd39[ii] ;
		cparam[OBR_CODE_NW7].bp[ii] = ObrModeTbl.Nw7[ii] ;
		cparam[OBR_CODE_WPCA].bp[ii] = ObrModeTbl.Wpcea[ii] ;
		cparam[OBR_CODE_WPC].bp[ii] = ObrModeTbl.Wpce[ii] ;
		cparam[OBR_CODE_UPCA].bp[ii] = ObrModeTbl.Upcea[ii] ;
		cparam[OBR_CODE_UPC].bp[ii] = ObrModeTbl.Upce[ii] ;
		cparam[OBR_CODE_IDF].bp[ii] = ObrModeTbl.Idsf[ii] ;
		cparam[OBR_CODE_ITF].bp[ii] = ObrModeTbl.Itrf[ii] ;
		cparam[OBR_CODE_CD93].bp[ii] = ObrModeTbl.Cd93[ii] ;
		cparam[OBR_CODE_CD128].bp[ii] = ObrModeTbl.Cd128[ii] ;
		cparam[OBR_CODE_MSI].bp[ii] = ObrModeTbl.Msi[ii] ;
		cparam[OBR_CODE_IATA].bp[ii] = ObrModeTbl.Iata[ii] ;
	}
	if (cparam[OBR_CODE_CD128].bp[OUTFORMATOP] == OBR_128AIM)
				cparam[OBR_CODE_CD128].bp[OUTFORMATOP] = SYM_CODE128AIM ;
	else if (cparam[OBR_CODE_CD128].bp[OUTFORMATOP] == OBR_128FNC)
				cparam[OBR_CODE_CD128].bp[OUTFORMATOP] = SYM_CODE128FNC ;


	return(iRet) ;
}



